package com.lj.Sirui;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.CoreConnectionPNames;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.util.EntityUtils;

public class HttpClientUtils
{
    private static final String CHARSET="UTF-8";
    
    /**
     * HttpClient POST方法
     * @param postUrl [接口URL]
     * @param param [接口公共参数]
     * @return
     */
    public static String httpPost(String postUrl,Map<String,String> param)
    {
        String result=null;
        DefaultHttpClient httpclient = new DefaultHttpClient();
        HttpParams params = createHttpParams();
        httpclient.setParams(params);
        HttpPost httpPost = new HttpPost(postUrl);
        try
        {
            //设置POST header
            //Content-Type只能设置为application/x-www-form-urlencoded;否则整体请求参数加密后的数据会丢失
            httpPost.setHeader("Content-Type", "application/x-www-form-urlencoded");

            //设置参数列表的位置
            //必须是这样子的哦，不可修改;否则调用接口时会报 验签失败3
            List<NameValuePair> namePairs = new ArrayList<NameValuePair>();
            namePairs.add(0, new BasicNameValuePair("srAppid",param.get("srAppid")));
            namePairs.add(1, new BasicNameValuePair("timestamp",param.get("timestamp")));
            namePairs.add(2, new BasicNameValuePair("nonce",param.get("nonce")));
            namePairs.add(3, new BasicNameValuePair("encodeData",param.get("encodeData")));
            namePairs.add(4, new BasicNameValuePair("signature",param.get("signature")));
            
            UrlEncodedFormEntity entity = new UrlEncodedFormEntity(namePairs, CHARSET);
            entity.setContentType("application/json");
            httpPost.setEntity(entity);

            HttpResponse  response = httpclient.execute(httpPost);
            if(response != null){
                HttpEntity resEntity = response.getEntity();
                if(resEntity != null){
                    result = EntityUtils.toString(resEntity,CHARSET);
                }
            }
        } catch (Exception e)
        {
            e.printStackTrace();
        }
        return result;
    }
    
    private static HttpParams createHttpParams() {
        /** 创建基本HTTP参数构建对象 */
        HttpParams params = new BasicHttpParams();
        /** 最大连接超时时间 */
        params.setParameter(CoreConnectionPNames.CONNECTION_TIMEOUT, 4000);
        /** 最大socket请求超时时间 */
        params.setParameter(CoreConnectionPNames.SO_TIMEOUT, 8000);
        /** 请求异常后是否继续 */
        HttpProtocolParams.setUseExpectContinue(params, true);
        HttpConnectionParams.setTcpNoDelay(params, true);
        /** 设置socket缓冲区大小 */
        HttpConnectionParams.setSocketBufferSize(params, 8192);
        return params;
    }
}
