package com.lj.lucene;

import com.lj.others.ResultSetToObject;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.IndexWriterConfig;
import org.apache.lucene.index.Term;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;

import java.io.IOException;
import java.nio.file.Paths;
import java.sql.ResultSet;
import java.util.List;

/**
 * Created by john on 2018/10/19.
 */
public class B2BUtil {
    public static Directory DIRECTORY = null;
    public static Analyzer ANALYZER = null;
    public static IndexWriter INDEXWRITER = null;
    public B2BUtil(String IndexPath, Analyzer analyzer) {
        ANALYZER = analyzer;
        try {
            DIRECTORY = FSDirectory.open(Paths.get(IndexPath));
            INDEXWRITER = new IndexWriter(DIRECTORY, new IndexWriterConfig(ANALYZER));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    public int CreateIndex(ResultSet rs, String[] not_anlyzedColumns, String[] toNumColumns, String[] not_storeColumns) {
        List<Document> documents = ResultSetToObject.B2BProductResultSetToDocuments(rs, not_anlyzedColumns, toNumColumns, not_storeColumns);
        for (Document doc : documents) {
            try {
                INDEXWRITER.addDocument(doc);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        if (INDEXWRITER != null) {
            try {
                INDEXWRITER.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        if (INDEXWRITER.getDirectory() != null) {
            try {
                INDEXWRITER.getDirectory().close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        return documents.size();
    }
    /**
     * 修改索引库索引
     *
     * @param field
     * @param value
     * @param doc
     * @return
     */
    public boolean UpdateSingleIndex(String field, String value, Document doc) {
        try {
            INDEXWRITER.updateDocument(new Term(field, value), doc);
            INDEXWRITER.commit();
            //INDEXWRITER.close();
            //DIRECTORY.close();
            return true;
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        }
    }
    /**
     * 向索引库新增一条索引
     *
     * @param doc
     * @return
     */
    public boolean InsertSingleIndex(Document doc) {
        try {
            INDEXWRITER.addDocument(doc);
            INDEXWRITER.commit();
            return true;
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        }
    }
    /**
     * 在索引库中删除一条索引
     *
     * @param field
     * @param value
     * @return
     */
    public boolean DeleteSiginIndexByKey(String field, String value) {
        try {
            INDEXWRITER.deleteDocuments(new Term(field, value));
            INDEXWRITER.commit();
            return true;
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        }
    }
    /**
     * 删除目录下所有索引
     */
    public boolean DeleteAllIndex() {
        try {
            INDEXWRITER.deleteAll();
            INDEXWRITER.commit();
            return true;
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        }

    }

}
