package com.lj.lucene;
import com.lj.others.*;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.DirectoryReader;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.Term;
import org.apache.lucene.queryparser.classic.MultiFieldQueryParser;
import org.apache.lucene.queryparser.classic.ParseException;
import org.apache.lucene.queryparser.classic.QueryParser;
import org.apache.lucene.search.*;
import org.apache.lucene.search.highlight.*;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by john on 2018/10/22.
 */
public class B2BUtil_R {
    private static Directory DIRECTORY = null;
    private static Analyzer ANALYZER = null;
    private static IndexReader INDEXREADER = null;
    private static IndexSearcher INDEXSEARCHER = null;

    public B2BUtil_R(String IndexPath, Analyzer analyzer) {
        ANALYZER = analyzer;
        try {
            DIRECTORY = FSDirectory.open(Paths.get(IndexPath));
            INDEXREADER = DirectoryReader.open(DIRECTORY);
            INDEXSEARCHER = new IndexSearcher(INDEXREADER);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public UIB2BProduct
    SearchProduct(List<String> fields, String _input, Boolean ishlight) {

        UIB2BProduct _uiProduct = new UIB2BProduct();
        BooleanQuery.Builder builder = new BooleanQuery.Builder();
        String[] fieldsTemp = new String[fields.size()];
        for (int i = 0; i < fields.size(); i++) {
            fieldsTemp[i] = fields.get(i);
        }
        //多条件查询神器
        QueryParser parser = new MultiFieldQueryParser(fieldsTemp, ANALYZER);
        try {
            Query query = parser.parse(_input);
            builder.add(query, BooleanClause.Occur.MUST);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        TermQuery query4 = new TermQuery(new Term("productstatustype", "1"));
        TermQuery query5 = new TermQuery(new Term("productstatustype", "3"));
        builder.add(query4, BooleanClause.Occur.SHOULD);
        builder.add(query5, BooleanClause.Occur.SHOULD);
        TermQuery query = new TermQuery(new Term("price1", "0000000"));
        builder.add(query, BooleanClause.Occur.MUST_NOT);

        try {

            TopDocs tds = null;
            tds = INDEXSEARCHER.search(builder.build(), 500);
            //注意 此处把500条数据放在内存里。
            ScoreDoc[] sds = tds.scoreDocs;
            int _totalhits = tds.totalHits;
            if (_totalhits > 500) {
                _uiProduct.setRowCount(500);
                _totalhits = 500;
            } else {
                _uiProduct.setRowCount(tds.totalHits);
            }
            if (tds.totalHits > 0) {
                for (int i = 0; i < _totalhits; i++) {
                    Document doc = INDEXSEARCHER.doc(sds[i].doc);
                    String[] _columns = Config.getProductB2BFileds();
                    String[] _colunmsValues = new String[_columns.length];
                    for (int k = 0; k < _columns.length; k++) {
                        if (ishlight == true && fields.contains(_columns[k])) {
                            try {
                                //这里进行高亮处理
                                SimpleHTMLFormatter simpleHtmlFormatter = new SimpleHTMLFormatter("<B>", "</B>");
                                Highlighter highlighter = new Highlighter(simpleHtmlFormatter, new QueryScorer(builder.build()));
                                highlighter.setTextFragmenter(new SimpleFragmenter(500));
                                String _temp = highlighter.getBestFragment(ANALYZER, _columns[k], doc.get(_columns[k]));
                                if (_temp != null) {
                                    _colunmsValues[k] = _temp;
                                } else {
                                    _colunmsValues[k] = doc.get(_columns[k]);
                                }
                            } catch (InvalidTokenOffsetsException e) {
                                String ex=e.getMessage();
                                e.printStackTrace();
                            }catch (NumberFormatException e){
                                String ex=e.getMessage();
                                e.printStackTrace();
                            }
                        } else {

                            try {
                                _colunmsValues[k] = doc.get(_columns[k]);
                            }catch (NumberFormatException e){
                                String ex=e.getMessage();
                                e.printStackTrace();
                            }
                        }
                    }

                    B2BProduct product = new B2BProduct();
                    product.SetValues(_colunmsValues);
                    _uiProduct.productList.add(product);
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return _uiProduct;
    }

    public List<Lianxian> ThinkSearch(String input, String[] fields, String resultColumnsName) {
        List<B2BProduct> list = new ArrayList<B2BProduct>();
        List<Lianxian> _list = new ArrayList<Lianxian>();
        Query q = null;
        try {
            MultiFieldQueryParser m_parser = new MultiFieldQueryParser(fields, ANALYZER);
            q = m_parser.parse(input);
            try {
                TopDocs tds = INDEXSEARCHER.search(q, 500);
                ScoreDoc[] sds = tds.scoreDocs;

                int end = 0;
                if (tds.totalHits >= 500)
                    end = 500;
                else
                    end = tds.totalHits;


                for (int i = 0; i < end; i++) {
                    Document doc = INDEXSEARCHER.doc(sds[i].doc);
                    String _commonTitle = doc.get("productname").trim();
                    String _braneName=doc.get("brandname").trim();
                    String commTitle2 = "";
                    if (_commonTitle.indexOf("(") > -1 || _commonTitle.indexOf("（") > -1) {
                        String _temp = _commonTitle.replace('（', '(');
                        commTitle2 = _temp.substring(0, _temp.indexOf("("));
                    } else {
                        commTitle2 = _commonTitle;
                    }

                    String _lxcontent = commTitle2.trim();
                    String _pyall = doc.get("pyall");
                    _pyall = _pyall == null ? "" : _pyall;
                    String _pyhc = doc.get("pyhc");
                    _pyhc = _pyhc == null ? "" : _pyhc;
                    long result = _list.stream().filter((Lianxian l) -> l.getKindname().equals(_lxcontent.trim())).count();
                    if (result == 0) {
                        Lianxian _lianxian = new Lianxian();
                        String [] arrs=_lxcontent.split(" ");
                        if(arrs.length>2)
                        _lianxian.setKindname(arrs[0]+" "+arrs[1]);
                        else
                            _lianxian.setKindname(arrs[0]);

                        _list.add(_lianxian);
                    }
                }


            } catch (IOException e) {
                e.printStackTrace();
            }
        } catch (ParseException e) {
            e.printStackTrace();
        }

        return _list;
    }

    public String contact(String[] kws) {
        String contactkws = "";
        for (String str : kws) {
            if (str.length() > 1) {
                contactkws = contactkws + str;
            }
        }
        return contactkws;
    }
}
