package com.lj.others;

import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by john on 2018/10/23.
 */
public class B2BFilter {

    public static Object FilterProduct(UIB2BProduct _uiproduct, String[] MustKeys, String _sorts, String _isprescription,
                                       int pagesize, int pageindex,
                                       boolean Ispinyincheck, String[] tongyipy, String[] SynonArr) {

        //对分词的完善
        UIB2BProduct _uipTemp = Ispinyincheck == true ? FilterProduct(_uiproduct, tongyipy) : FilterNormal(_uiproduct, MustKeys, SynonArr);

        if (_isprescription != null&&!("").equals(_isprescription)) {
            if (_isprescription.equals("1")) {
                List<B2BProduct> _list = _uipTemp.productList.stream().filter((B2BProduct b) ->
                        (Integer.parseInt(b.prescriptiontype) == 4
                                || Integer.parseInt(b.prescriptiontype) == 5)).collect(Collectors.toList());
                _uipTemp.setProductList(_list);
            } else {
                List<B2BProduct> _list = _uipTemp.productList.stream().filter((B2BProduct b) -> (Integer.parseInt(b.prescriptiontype) == 0
                        || Integer.parseInt(b.prescriptiontype) == 2
                        || Integer.parseInt(b.prescriptiontype) == 3
                        || Integer.parseInt(b.prescriptiontype) == 9)).collect(Collectors.toList());
                _uipTemp.setProductList(_list);
            }
        }
        if(_uipTemp.productList.size()>0) {
            List<B2BProduct> _list = _uipTemp.productList.stream().filter((B2BProduct b) ->
                    b.productstatustype == 1
                            || b.productstatustype == 3).collect(Collectors.toList());
            _uipTemp.setProductList(_list);
        }





        //定义一个存储排序字段的HaspMap
        Map<String, String> sorts = new HashMap<String, String>();
        if (_sorts != null&&!_sorts.equals("")) {
            String[] _sorsTemp = _sorts.split(",");
            for (int i = 0; i < _sorsTemp.length; i++) {
                String[] _sortSplit = _sorsTemp[i].split("-");
                sorts.put(_sortSplit[0], _sortSplit[1]);
            }
        }


        if (sorts.size() > 0) {
            for (String key : sorts.keySet()) {
                if (key.equals("price")) {
                    String _value = sorts.get(key);
                    if (_value.toLowerCase().equals("asc")) {
                        Collections.sort(_uipTemp.productList, new SortB2BPrice());
                    } else if (_value.toLowerCase().equals("desc")) {
                        Collections.sort(_uipTemp.productList, new SortB2BPriceDesc());
                    }
                }
            }
        }
        _uipTemp.setRowCount(_uipTemp.getProductList().size());
        int total = _uipTemp.getProductList().size();
        int start = (pageindex - 1) * pagesize;
        int end = pageindex * pagesize;
        end = end > total ? total : end;

        UIB2BProduct2 _resultTemp = new UIB2BProduct2();
        for (int i = start; i < end; i++) {
            B2BProduct pro = _uipTemp.getProductList().get(i);
            B2BProduct2 _pro3 = new B2BProduct2();
            _pro3.productcode = pro.productcode;
            _pro3.productname = pro.productname;
            _pro3.commontitle = pro.commontitle;
            _pro3.introduction = pro.introduction;
            _pro3.manufacturer = pro.manufacturer;
            _pro3.packing = pro.packing;
            _pro3.prescriptiontype = pro.prescriptiontype;
            _pro3.productimgurl = pro.productimgurl;
            _pro3.price1=pro.price1;
            _pro3.price2=pro.price2;
            _pro3.price3=pro.price3;
            _pro3.price4=pro.price4;
            _pro3.ispiece=pro.ispiece;
            _pro3.approvalnumber=pro.approvalnumber;
            _pro3.barcode=pro.barcode;
            _pro3.stock=pro.stock;
            _pro3.unit=pro.unit;
            _pro3.piecequantity=pro.piecequantity;
            _pro3.wholequantity=pro.wholequantity;
            _pro3.marketprice=pro.marketprice;
            _pro3.batchcode=pro.batchcode;
            _pro3.validitydate=pro.validitydate;
            _resultTemp.productList.add(_pro3);
        }
        _resultTemp.setRowCount(_uipTemp.getProductList().size());
        return _resultTemp;

    }


    private static UIB2BProduct FilterNormal(UIB2BProduct _uiproduct, String[] MustKeys, String[] SynonArr) {
        UIB2BProduct _uipTemp = _uiproduct;
        UIB2BProduct _uipTemp2 = _uiproduct;
        UIB2BProduct _uipTemp3 = _uiproduct;

        //没有同义词的词组,对搜索结果交集处理
        if (SynonArr.length == 0) {
            for (int i = 0; i < MustKeys.length; i++) {
                _uipTemp = FilterProduct(_uipTemp, MustKeys[i], true);
            }
        } else {
            //对MustKeys交集处理,对同义词并集处理
            for (int i = 0; i < MustKeys.length; i++) {
                _uipTemp = FilterProduct(_uipTemp, MustKeys[i], true);
            }

            if (_uipTemp.productList.size() == 0) {
                for (int i = 0; i < MustKeys.length; i++) {
                    _uipTemp2 = FilterProduct(_uipTemp2, MustKeys[i], false);
                }
                _uipTemp = _uipTemp2.productList.size() == 0 ? _uiproduct : _uipTemp2;
                _uipTemp.setRowCount(_uipTemp.getRowCount() + _uipTemp2.productList.size());
            }

            //将同义词的搜索结果加上
            _uipTemp3 = FilterProduct2(_uiproduct, SynonArr);
            if (_uipTemp3.getProductList().size() > 0) {
                _uipTemp.getProductList().addAll(_uipTemp3.getProductList());
                _uipTemp.setRowCount(_uipTemp.getRowCount() + _uipTemp3.getRowCount());
            }

        }

        //关键词没有搜索到,对数据进行并集处理处理
        if (_uipTemp.productList.size() == 0) {
            for (int i = 0; i < MustKeys.length; i++) {
                _uipTemp2 = FilterProduct(_uipTemp2, MustKeys[i], false);
            }
            _uipTemp = _uipTemp2.productList.size() == 0 ? _uiproduct : _uipTemp2;
        }

        return _uipTemp;

    }


    private static UIB2BProduct FilterProduct(UIB2BProduct _uiproduct, String[] tonyipy) {
        UIB2BProduct _uip = new UIB2BProduct();
        for (int i = 0; i < _uiproduct.getProductList().size(); i++) {
            B2BProduct _pro = _uiproduct.productList.get(i);
            String productname_pyall = ChineseToPinyin.getPingYin(_pro.getProductname()).toLowerCase();
            String manufacturer_pyall = ChineseToPinyin.getPingYin(_pro.getManufacturer()).toLowerCase();
            String commontitle_pyall = ChineseToPinyin.getPingYin(_pro.getCommontitle()).toLowerCase();
            String introduction_pyall = ChineseToPinyin.getPingYin(_pro.getIntroduction()).toLowerCase();

            String barcode_pyall=ChineseToPinyin.getPingYin(_pro.getBarcode()).toString();
            String approvalnumber_pyall=ChineseToPinyin.getPingYin(_pro.getApprovalnumber()).toString();


            if (
                    hascontact(productname_pyall, tonyipy)
                    || hascontact(manufacturer_pyall, tonyipy)
                    || hascontact(commontitle_pyall, tonyipy)
                  //  || hascontact(introduction_pyall, tonyipy)
                    ||hascontact(barcode_pyall,tonyipy)
                    ||hascontact(approvalnumber_pyall,tonyipy)
                    ) {

                    _uip.getProductList().add(_pro);

            }
        }

        _uip.setRowCount(_uip.getProductList().size());
        return _uip;
    }

    private static UIB2BProduct FilterProduct(UIB2BProduct _uiproduct, String _input, boolean is) {
        UIB2BProduct _uip = new UIB2BProduct();
        Boolean brance = false;
        _input = _input.toUpperCase().trim();
        for (int i = 0; i < _uiproduct.productList.size(); i++) {
            B2BProduct _pro = _uiproduct.productList.get(i);
            if (is) {
                if (i == 0) {
                    if (_pro.productname.toUpperCase().trim().contains(_input.trim())
                            || _pro.manufacturer.toUpperCase().trim().contains(_input.trim())) {
                        brance = true;
                    }
                }
            }
            if (brance) {
                if (((_pro.productname.toUpperCase().trim().contains(_input) || _pro.manufacturer.toUpperCase().trim().contains(_input)) &&
                        (_pro.productcode.toUpperCase().trim().contains(_input)
                                || _pro.productname.toUpperCase().trim().contains(_input)
                                || _pro.commontitle.toUpperCase().trim().contains(_input)
                                || _pro.introduction.toUpperCase().trim().contains(_input)
                                || _pro.manufacturer.toUpperCase().trim().contains(_input)
                                || _pro.barcode.toUpperCase().trim().contains(_input)
                                || _pro.approvalnumber.toUpperCase().trim().contains(_input)
                                || _pro.pyall.toUpperCase().contains(_input)
                                || _pro.pyhc.toUpperCase().contains(_input)))) {
                    _uip.productList.add(_pro);
                }
            } else {
                if ((_pro.productcode.toUpperCase().trim().contains(_input) ||
                        _pro.productname.toUpperCase().trim().contains(_input) ||
                        _pro.commontitle.toUpperCase().trim().contains(_input) ||
                        _pro.introduction.toUpperCase().trim().contains(_input) ||
                        _pro.manufacturer.toUpperCase().trim().contains(_input) ||
                        _pro.barcode.toUpperCase().trim().contains(_input)||
                        _pro.approvalnumber.toUpperCase().contains(_input)||
                        _pro.pyall.toUpperCase().contains(_input) ||
                        _pro.pyhc.toUpperCase().contains(_input))) {
                    _uip.productList.add(_pro);
                }
            }
        }
        return _uip;
    }


    private static UIB2BProduct FilterProduct2(UIB2BProduct _uiproduct, String[] keys) {
        UIB2BProduct _uip = new UIB2BProduct();
        for (int i = 0; i < _uiproduct.getProductList().size(); i++) {
            B2BProduct _pro = _uiproduct.productList.get(i);
            String productname = _pro.getProductname().toLowerCase().trim();
            String manufacturer = _pro.getManufacturer().toLowerCase().trim();
            String commontitle = _pro.getCommontitle().toLowerCase().trim();
            String introduction = _pro.getIntroduction().toLowerCase().trim();
            String barcode=_pro.getBarcode().toLowerCase().trim();
            String approvalnumber=_pro.getApprovalnumber().toLowerCase().trim();


            if (hascontact(productname, keys)
                    || hascontact(manufacturer, keys)
                    || hascontact(commontitle, keys)
                    || hascontact(introduction, keys)
                    ||hascontact(barcode,keys)
                    ||hascontact(approvalnumber,keys)
                    ) {
                _uip.getProductList().add(_pro);
            }
        }

        _uip.setRowCount(_uip.getProductList().size());
        return _uip;
    }


    protected static boolean contactCode(String productcode, List<String> _list) {
        for (String _productcode : _list) {
            if (_productcode.trim().equals(productcode.trim())) {
                return true;
            }
        }
        return false;
    }


    protected static boolean hascontact(String content, String[] keys) {
        for (String key : keys) {
            String[] _keyArr = key.toLowerCase().trim().split(" ");

            boolean isAsc = true;
            List<String> bools = new ArrayList<String>();
            for (int i = 0; i < _keyArr.length; i++) {
                if (content.contains(_keyArr[i])) {
                    bools.add("true");
                } else {
                    bools.add("false");
                }

            }

            for (String bolstr : bools) {
                if ("false".equals(bolstr)) {
                    isAsc = false;
                    break;
                }
            }


            boolean isDesc = true;
            List<String> bools2 = new ArrayList<String>();
            for (int i = _keyArr.length - 1; i >= 0; i--) {
                if (content.contains(_keyArr[i])) {
                    bools2.add("true");
                } else {
                    bools2.add("false");
                }
            }

            for (String bolstr : bools2) {
                if ("false".equals(bolstr)) {
                    isDesc = false;
                    break;
                }
            }
            if (isAsc || isDesc) {
                return true;
            }
        }
        return false;

    }

}
