package com.lj.others;

import com.lj.lucene.B2BUtil;
import com.lj.lucene.B2BUtil_R;
import com.lj.lucene.IndexUtil;
import com.lj.lucene.IndexUtil_R;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.apache.lucene.document.Document;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Created by john on 2018/10/22.
 */
public class B2BHTTPMethod {

    static B2BUtil b2bUtil = null;
    static B2BUtil_R b2bUtil_R = null;
    static final int SOURFCE_WORDS_MAX = 5;
    static final int PINYIN_WORDS_MAX = 2;
    static final int SPLIT_WORDS_INDEX = 0;

    static final int PINYIN_INVALID_LENGTH = 3;
    static final int CHINESE_INVALID_LENGTH = 1;


    public B2BHTTPMethod(B2BUtil _indexUtil, B2BUtil_R _indexUtil_r) {
        this.b2bUtil = _indexUtil;
        this.b2bUtil_R = _indexUtil_r;
    }

    public void search(HttpServletRequest req, HttpServletResponse response) {
        String _callback = req.getParameter("callback") == null ? "" : req.getParameter("callback");
        String _input = req.getParameter("kw") == null ? "" : req.getParameter("kw");
        int _pageindex = req.getParameter("pageindex") == null ? 1 : Integer.parseInt(req.getParameter("pageindex"));
        int _pagesize = req.getParameter("pagesize") == null ? 6 : Integer.parseInt(req.getParameter("pagesize"));
        boolean _ishlight = req.getParameter("ishlight") == null ? false : true;
        boolean _boolSmart = req.getParameter("smart") == null ? false : true;
        if ("".equals(_input)) {
            String json = "{\"result\":{\"productList\":[],\"rowCount\":0}}";
            Other.ResponseResult3(response, json.toString());
            return;
        }
        String ip = req.getParameter("ip") == null ? "127.0.0.1" : req.getParameter("ip");
        boolean isEnglish = Other.isEnglish(_input);
        List<String> rejectcodes = new ArrayList<String>();

        //获取前端传来的字段参数，多个字段用英文逗号分隔
        List<String> _fields = Config.GetB2BProductSearchFileds();
        String fields = req.getParameter("fields");
        if (fields != null) {
            String[] _fieldsTemp = fields.split(",");
            for (int i = 0; i < _fieldsTemp.length; i++) {
                if (!_fields.contains(_fieldsTemp[i])) {
                    _fields.add(_fieldsTemp[i]);
                }
            }
        }
        //获取前端传来的排序,支持多个字段排序，多个字段之间用英文分隔 sort=IsHomePageTop-DESC,PV-ASC
        String _sort = req.getParameter("sort");//== null ? "views-desc" : req.getParameter("sort");
        //字段筛选
        String _isprescription = req.getParameter("isprescription");


        //记录没有分词时的关键词
        String _sinput = _input;
        String[] kwsTemp = Config.DealSynonym.Deal(_input, true).trim().split(" ");
        List<String> keysList = Arrays.asList(kwsTemp);
        if (isEnglish)
            keysList = keysList.stream().filter((String w) -> w.length() > PINYIN_INVALID_LENGTH).collect(Collectors.toList());
        else
            keysList = keysList.stream().filter((String w) -> w.length() > CHINESE_INVALID_LENGTH).collect(Collectors.toList());

        String[] keys = keysList.toArray(new String[keysList.size()]);
        _input = org.apache.commons.lang.StringUtils.join(keysList.toArray(), " ");
        String[] tongyipy = Other.GetPinYinListAttach(_input);
        //获取同义词
        List<String> synonyms = Other.findsynonyms(_sinput, keysList);
        String[] SynonArr = synonyms.toArray(new String[synonyms.size()]);
        boolean hassynonyms = synonyms.size() > 0 ? true : false;
        //去掉同义词,这个地方选交集
        String[] MustKeys = null;
        if (!isEnglish) {
            MustKeys = Other.removesynonyms(keys, synonyms);
        } else {
            MustKeys = new String[1];
            MustKeys[0] = _sinput;
        }


        boolean Ispinyincheck = false;
        //判断是否分词过
        //获取长度最大的元素的索引
        if (keys.length > 0) {
            //分词过后最大的元素
            String _maxword = Other.GetMaxItem(keys);
            //已经分过词了
            if (_sinput.toUpperCase().trim().indexOf(_maxword.toUpperCase().trim()) > SPLIT_WORDS_INDEX ||
                    (_sinput.toUpperCase().trim().length() <= SOURFCE_WORDS_MAX & _maxword.toUpperCase().length() == PINYIN_WORDS_MAX)) {
                Ispinyincheck = true;
            }
        }

        //输入关键词长度大于5需要分词,不开启拼音纠错
        if (_sinput.length() > SOURFCE_WORDS_MAX) {
            Ispinyincheck = false;
        }

        UIB2BProduct uiProduct = null;
        if (Ispinyincheck == true || "".equals(_input.trim()) || isEnglish) {
            //拼音同义词的转换
            if (keys.length < PINYIN_WORDS_MAX) {
                tongyipy = Other.GetPinYinListAttach(_sinput);
            }
            String _pinyins = org.apache.commons.lang.StringUtils.join(tongyipy, " ");
            uiProduct = b2bUtil_R.SearchProduct(_fields, _pinyins.trim(), _ishlight);
            Ispinyincheck = true;
        } else {
            uiProduct = b2bUtil_R.SearchProduct(_fields, _input.trim(), _ishlight);
            Ispinyincheck = false;
        }

        Object FilteruiProduct = B2BFilter.FilterProduct(uiProduct, MustKeys, _sort, _isprescription, _pagesize, _pageindex, Ispinyincheck, tongyipy, SynonArr);
        JSONObject json = JSONObject.fromObject(FilteruiProduct);//将java对象转换为json对象
        Other.ResponseResult(response, json.toString());
    }

    public void update(HttpServletRequest request, HttpServletResponse response) {
        String productcode = request.getParameter("productcode");
        ResultSet rs = SQLHelper.executeQuery("USE B2BMall " +
                "SELECT \n" +
                "A.ProductCode,\n" +
                "A.ProductName,\n" +
                "A.BarCode,\n" +
                "A.ApprovalNumber,\n" +
                "A.PrescriptionType,\n" +
                "A.Packing,\n" +
                "A.CommonTitle,\n" +
                "A.Manufacturer,\n" +
                "A.Introduction,\n" +
                "ISNULL(A.[Manual],'') [Manual],\n" +
                "ISNULL(A.Standards,'') Standards,\n" +
                "ISNULL(A.Dosage,'') Dosage,\n" +
                "ISNULL(A.Characters,'') Characters,\n" +
                "ISNULL(A.Adverse,'') Adverse,\n" +
                "ISNULL(A.Taboo,'') Taboo,\n" +
                "ISNULL(A.Precautions,'') Precautions,\n" +
                "ISNULL(A.Child,'') Child,\n" +
                "ISNULL(A.OlderPatients,'') OlderPatients,\n" +
                "ISNULL(A.PregnantWoman,'') PregnantWoman,\n" +
                "ISNULL(A.DrugInteractions,'') DrugInteractions,\n" +
                "ISNULL(A.Overdose,'') Overdose,\n" +
                "ISNULL(A.Pharmaco,'') Pharmaco,\n" +
                "ISNULL(A.Pharmacokinetics,'') Pharmacokinetics ,\n" +
                "ISNULL(A.PackingProduct,'') PackingProduct,\n" +
                "ISNULL(A.MarketPrice,0) MarketPrice,\n" +
                "ISNULL(A.ClassCode,'') ClassCode,\n" +
                "ISNULL(A.CategoryCode,'') CategoryCode,\n" +
                "ISNULL(A.ProductImgUrl,'') ProductImgUrl,\n" +
                "ISNULL(A.AvgPrice,0) AvgPricem,\n" +
                "ISNULL(A.LastPrice,0) LastPrice,\n" +
                "ISNULL(A.PreviousPrice,0) PreviousPrice,\n" +
                "ISNULL(A.Price1,0) Price1,\n" +
                "ISNULL(A.Price2,0) Price2,\n" +
                "ISNULL(A.Price3,0) Price3,\n" +
                "ISNULL(A.Price4,0) Price4,\n" +
                "A.IsPiece,\n" +
                "ISNULL(A.WholeQuantity,0) WholeQuantity,\n" +
                "ISNULL(A.ERPID,'') ERPID,\n" +
                "ISNULL(A.BrandName,'') BrandName,\n" +
                "ISNULL(A.Unit,'') Unit,\n" +
                "ISNULL(A.PieceQuantity ,'') PieceQuantity,\n" +
                "ISNULL(A.ProductStatusType ,0) ProductStatusType,\n" +
                "C.Stock Stock, \n" +
                "ISNULL(C.BatchCode,'') BatchCode,\n" +
                "ISNULL(C.ValidityDate,'') ValidityDate " +
                "FROM Product A\n" +
                "OUTER APPLY\n" +
                "(\n" +
                " SELECT  ISNULL(SUM(B.StockAmount),0) Stock,MAX(B.BatchCode) BatchCode,MAX(B.ValidityDate) ValidityDate  FROM dbo.ProductBatch B WHERE B.ProductCode=A.ProductCode and B.InvaildStatus=0 \n" +
                ") C\n" +
                "WHERE A.ProductCode="+productcode);

        String[] not_analyzedColumns = {"ProductCode", "BarCode", "PrescriptionType", "IsPiece", "WholeQuantity", "ERPID", "Stock", "ProductImgUrl", "ClassCode", "WholeQuantity", "ERPID","ProductStatusType","BatchCode","ValidityDate"};
        String[] numericColumns = {"AvgPricem", "LastPrice","PreviousPrice","Price1","Price2","Price3","Price4"};
        String[] pinyinColumns = {"BrandName", "ProductName","Manufacturer"};
        List<Document> docs = ResultSetToObject.B2BProductResultSetToDocuments(rs, not_analyzedColumns, numericColumns, pinyinColumns);
        Other.ResponseResult(response, "B2B更新条数：" + docs.size());
        b2bUtil.DeleteSiginIndexByKey("productcode", productcode);
        Other.ResponseResult(response, "B2B删除索引：" + docs.size());
        if (docs.size() > 0) {
            b2bUtil.InsertSingleIndex(docs.get(0));
            Other.ResponseResult(response, "update");
        }
        Other.ResponseResult(response, "1");
    }

    public void think(HttpServletRequest request, HttpServletResponse response) {
        String _callback = request.getParameter("callback") == null ? "" : request.getParameter("callback");
        String _input = request.getParameter("kw") == null ? "" : request.getParameter("kw");
        String _showfield = request.getParameter("showfield") == null ? "productname" : request.getParameter("showfield");

        try {

            int _size = request.getParameter("size") == null ? 15 : Integer.parseInt(request.getParameter("size"));
            //_input = Other.GetBaiduJiuError(_input);
            String[] kwsTemp = Config.DealSynonym.Deal(_input, true).trim().split(" ");
            List<String> keysList = Arrays.asList(kwsTemp);
            keysList = keysList.stream().filter((String w) -> w.length() > 1).collect(Collectors.toList());
            String _sinput = _input;
            String[] keys = keysList.toArray(new String[keysList.size()]);
            _input = org.apache.commons.lang.StringUtils.join(keys, " ");
            String _pinyins = org.apache.commons.lang.StringUtils.join(keysList.toArray(), " ");
            //获取同义词
            List<String> synonyms = Other.findsynonyms(_sinput, keysList);
            //去掉同义词
            String[] newkeys = Other.removesynonyms(keys, synonyms);
            //新词累加同义词
            List<String> ljkey = new ArrayList<String>();

            ljkey.addAll(Arrays.asList(newkeys));
            ljkey.addAll(synonyms);

            String[] _fields = Config.getlianxianSearchFileds();
            List<Lianxian> _list = b2bUtil_R.ThinkSearch(_input, _fields, _showfield);
            List<Lianxian> _rsultList = new ArrayList<Lianxian>();

            for (int i = _list.size() - 1; i >= 0; i--) {
                if (hasConttent(_list.get(i).getKindname(), ljkey) == true) {
                    _rsultList.add(_list.get(i));
                }
            }
            if (_rsultList.size() > _size) {
                _rsultList = _rsultList.subList(0, _size);
            }

            JSONArray json = JSONArray.fromObject(_rsultList);//将java对象转换为json对象
            Other.ResponseResult(response, _callback, json.toString());
        }catch (Exception ex){
            //String json = "{\"productList\":[],\"rowCount\":0}}";
            Other.ResponseResult(response,_callback,"[]");
        }

    }

    private boolean hasConttent(String key, List<String> keys) {
        for (String _key : keys) {
            if (key.toUpperCase().trim().contains(_key.toUpperCase().trim())) {
                return true;
            }
        }
        return false;
    }

}