package com.lj.others;

import com.lj.lucene.CMSUtil;
import com.lj.lucene.CMSUtil_R;
import net.sf.json.JSONObject;
import org.apache.lucene.analysis.Analyzer;
import org.wltea.analyzer.lucene.IKAnalyzer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by john on 2018/6/21.
 */
public class CMSHTTPMethod {
    static CMSUtil cmsUtil = null;
    static CMSUtil_R cmsUtil_r = null;
    public CMSHTTPMethod(CMSUtil _cmsUtil, CMSUtil_R cmsUtil_r) {
        this.cmsUtil = _cmsUtil;
        this.cmsUtil_r = cmsUtil_r;
    }
    public void search(HttpServletRequest req, HttpServletResponse response) {
        String _callback = req.getParameter("callback") == null ? "" : req.getParameter("callback");
        String _input = req.getParameter("kw") == null ? "" : req.getParameter("kw");
        int _pageindex = req.getParameter("pageindex") == null ? 1 : Integer.parseInt(req.getParameter("pageindex"));
        int _pagesize = req.getParameter("pagesize") == null ? 20 : Integer.parseInt(req.getParameter("pagesize"));
        boolean _ishlight = req.getParameter("ishlight") == null ? false : true;
        _input = Config.DealSynonym.Deal(_input, true);
        //把一个字的过滤掉
        String _inputTemp="";
        for(String str:_input.split(" ")){
            if(str.toUpperCase().trim().length()>1){
                _inputTemp=_inputTemp+str+" ";
            }
        }
        _input=_inputTemp;

        //获取前端传来的字段参数，多个字段用英文逗号分隔
        List<String> _fields = Config.getCMSSearchFileds();
        String fields = req.getParameter("fields");
        if (fields != null) {
            String[] _fieldsTemp = fields.split(",");
            for (int i = 0; i < _fieldsTemp.length; i++) {
                if (!_fields.contains(_fieldsTemp[i])) {
                    _fields.add(_fieldsTemp[i]);
                }
            }
        }

        //获取前端传来的排序,支持多个字段排序，多个字段之间用英文分隔 sort=IsHomePageTop-DESC,PV-ASC
        String _sort = req.getParameter("sort");
        //定义一个存储排序字段的HaspMap
        Map<String, String> sorts = new HashMap<String, String>();
        if (_sort != null) {
            String[] _sorsTemp = _sort.split(",");
            for (int i = 0; i < _sorsTemp.length; i++) {
                String[] _sortSplit = _sorsTemp[i].split("-");
                sorts.put(_sortSplit[0], _sortSplit[1]);
            }
        }

        //获取前端传来的阶段筛选，支持多个字段筛选，多个字段之间用英文逗号分隔 range=CreationDate{20180101-20180130}
        String _range = req.getParameter("range");
        //定义一个存储阶段筛选的HaspMap
        Map<String, String> range = new HashMap<String, String>();
        if (_range != null) {
            String[] _rangeTemp = _range.split(",");
            for (int i = 0; i < _rangeTemp.length; i++) {
                String[] _rangSplit = _rangeTemp[i].split("!");
                range.put(_rangSplit[0], _rangSplit[1].replace("!", ""));
            }
        }
        CMSArticles _CMSArticles = cmsUtil_r.SearchCMS(_fields, _input, sorts, range, _ishlight);
        String [] _inputs=_input.split(" ");
        Object _filterCMSArticles=cmsFilter.Filter(_CMSArticles,_inputs,_pageindex,_pagesize);
        JSONObject json = JSONObject.fromObject(_filterCMSArticles);//将java对象转换为json对象
        Other.ResponseResult(response, _callback, json.toString());

    }
    public void update(HttpServletRequest request, HttpServletResponse response) {
        String daid = request.getParameter("daid");
        IndexThread indexThread = new IndexThread("update", daid, cmsUtil);
        indexThread.start();
        Other.ResponseResult3(response, "1");
    }
    public void delete(HttpServletRequest request, HttpServletResponse response) {
        String daid = request.getParameter("daid");
        IndexThread indexThread = new IndexThread("delete", daid, cmsUtil);
        indexThread.start();
        Other.ResponseResult3(response, "1");
    }
    public void insert(HttpServletRequest request, HttpServletResponse response) {
        String daid = request.getParameter("daid");
        IndexThread indexThread = new IndexThread("insert", daid, cmsUtil);
        indexThread.start();
        Other.ResponseResult3(response, "1");
    }
    public void deleteallindex(HttpServletRequest request, HttpServletResponse response) {
        cmsUtil.DeleteAllIndex();
        Other.ResponseResult3(response, "1");
    }
}
