package com.lj.others;

import net.sf.json.JSON;
import net.sf.json.JSONArray;
import org.apache.lucene.queryparser.xml.builders.SpanFirstBuilder;
import org.apache.lucene.search.SortField;

import java.sql.Array;
import java.text.Collator;
import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by john on 2018/7/2.
 */
public class Filter {

    public static Object FilterProduct(UIProduct _uiproduct, String[] MustKeys,
                                       String _ranges, String _sorts,
                                       String _isprescription, String _formulationcode,
                                       String _hastockprice,
                                       int pagesize, int pageindex,
                                       List<String> rejectcodes,
                                       boolean Ispinyincheck, String[] tongyipy, String[] SynonArr) {

        //对分词的完善
        UIProduct _uipTemp = Ispinyincheck == true ? FilterProduct(_uiproduct, tongyipy,MustKeys) : FilterNormal(_uiproduct, MustKeys, SynonArr);
        Map<String, String> ranges = new HashMap<String, String>();
        if (_ranges != null) {
            String[] _rangeTemp = _ranges.split("!");
            for (int i = 0; i < _rangeTemp.length; i++) {
                ranges.put(_rangeTemp[0], _rangeTemp[1]);
            }
        }

        if (ranges.size() > 0) {
            for (String key : ranges.keySet()) {
                if (key.equals("ourprice")) {
                    String[] _value = ranges.get(key).split("-");
                    if (_value.length == 1) {
                        int lowprice = Integer.parseInt(_value[0]);
                        List<Product> _list = _uipTemp.productList.stream().filter((Product b) ->
                                (Integer.parseInt(b.ourprice) > lowprice
                                        && Integer.parseInt(b.ourprice) <= 1000000000))
                                .collect(Collectors.toList());
                        _uipTemp.setProductList(_list);
                    } else {
                        int lowprice = Integer.parseInt(_value[0]);
                        int maxprice = Integer.parseInt(_value[1]);
                        List<Product> _list = _uipTemp.productList.stream().filter((Product b) ->
                                (Integer.parseInt(b.ourprice) > lowprice
                                        && Integer.parseInt(b.ourprice) <= maxprice))
                                .collect(Collectors.toList());
                        _uipTemp.setProductList(_list);
                    }

                }
            }
        }


        if (_isprescription != null) {
            if (_isprescription.equals("1")) {
                List<Product> _list = _uipTemp.productList.stream().filter((Product b) ->
                        (Integer.parseInt(b.prescriptiontype) == 4
                                || Integer.parseInt(b.prescriptiontype) == 5)).collect(Collectors.toList());
                _uipTemp.setProductList(_list);
            } else {
                List<Product> _list = _uipTemp.productList.stream().filter((Product b) -> (Integer.parseInt(b.prescriptiontype) == 0
                        || Integer.parseInt(b.prescriptiontype) == 2
                        || Integer.parseInt(b.prescriptiontype) == 3
                        || Integer.parseInt(b.prescriptiontype) == 9)).collect(Collectors.toList());
                _uipTemp.setProductList(_list);
            }
        }

        if (_formulationcode != null) {
            List<Product> _list = _uipTemp.productList.stream().filter((Product b) ->
                    (Integer.parseInt(b.formulationcode) == Integer.parseInt(_formulationcode))).collect(Collectors.toList());
            _uipTemp.setProductList(_list);
        }

        if (rejectcodes.size() > 0) {
            List<Product> _list = _uipTemp.productList.stream()
                    .filter((Product b) -> !rejectcodes.contains(b.productcode))
                    .collect(Collectors.toList());
            _uipTemp.setProductList(_list);
        }


        //定义一个存储排序字段的HaspMap
        Map<String, String> sorts = new HashMap<String, String>();
        if (_sorts != null) {
            String[] _sorsTemp = _sorts.split(",");
            for (int i = 0; i < _sorsTemp.length; i++) {
                String[] _sortSplit = _sorsTemp[i].split("-");
                sorts.put(_sortSplit[0], _sortSplit[1]);
            }
        }


        if (sorts.size() > 0) {
            for (String key : sorts.keySet()) {
                if (key.equals("ourprice")) {
                    String _value = sorts.get(key);
                    if (_value.toLowerCase().equals("asc")) {
                        Collections.sort(_uipTemp.productList, new SortPrice());
                    } else if (_value.toLowerCase().equals("desc")) {
                        Collections.sort(_uipTemp.productList, new SortPriceDesc());
                    }
                }

                if (key.contains("productcode")) {
                    String _value = sorts.get(key);
                    if (_value.toLowerCase().equals("asc")) {
                        Collections.sort(_uipTemp.productList, new SortDate());
                    } else if (_value.toLowerCase().equals("desc")) {
                        Collections.sort(_uipTemp.productList, new SortDateDesc());
                    }
                }


                if (key.contains("views")) {
                    String _value = sorts.get(key);
                    if (_value.toLowerCase().equals("asc")) {
                        Collections.sort(_uipTemp.productList, new SortView());
                    } else if (_value.toLowerCase().equals("desc")) {
                        Collections.sort(_uipTemp.productList, new SortViewDesc());
                    }
                }

            }
        }
        _uipTemp.setRowCount(_uipTemp.getProductList().size());
        int total = _uipTemp.getProductList().size();
        int start = (pageindex - 1) * pagesize;
        int end = pageindex * pagesize;
        end = end > total ? total : end;

        if (_hastockprice == null) {
            _hastockprice = "111111";
        }

        if (_hastockprice.equals("000000")) {
            UIProduct2 _resultTemp = new UIProduct2();
            for (int i = start; i < end; i++) {
                Product pro = _uipTemp.getProductList().get(i);
                Product2 _pro2 = new Product2();
                _pro2.productcode = pro.productcode;
                _pro2.productname = pro.productname;
                _pro2.commontitle = pro.commontitle;
                _pro2.introduction = pro.introduction;
                _pro2.manufacturer = pro.manufacturer;
                _pro2.marketprice = pro.marketprice;
                _pro2.ourprice = pro.ourprice;
                _pro2.profitlevel = pro.profitlevel;
                _pro2.packing = pro.packing;
                _pro2.thumbnailurl = pro.thumbnailurl;
                _pro2.prescriptiontype = pro.prescriptiontype;
                _pro2.img100 = pro.img100;
                _pro2.productimageurl = pro.productimageurl;
                _pro2.img180 = pro.img180;
                _pro2.classcode = pro.classcode;
                _pro2.productstatustype = pro.productstatustype;
                _pro2.quantity = pro.quantity;
                _pro2.xquantity = pro.xquantity;
                _pro2.producttag = pro.producttag;
                _pro2.formulationcode = pro.formulationcode;
                _pro2.purchaseprice = pro.purchaseprice;
                _pro2.categorytype = pro.categorytype;
                _resultTemp.productList2.add(_pro2);
            }
            _resultTemp.setRowCount(_uipTemp.getProductList().size());
            return _resultTemp;
        } else {
            UIProduct3 _resultTemp = new UIProduct3();
            for (int i = start; i < end; i++) {
                Product pro = _uipTemp.getProductList().get(i);
                Product3 _pro3 = new Product3();
                _pro3.productcode = pro.productcode;
                _pro3.productname = pro.productname;
                _pro3.commontitle = pro.commontitle;
                _pro3.introduction = pro.introduction;
                _pro3.manufacturer = pro.manufacturer;
                _pro3.marketprice = pro.marketprice;
                _pro3.ourprice = pro.ourprice;
                _pro3.profitlevel = pro.profitlevel;
                _pro3.packing = pro.packing;
                _pro3.thumbnailurl = pro.thumbnailurl;
                _pro3.prescriptiontype = pro.prescriptiontype;
                _pro3.img100 = pro.img100;
                _pro3.productimageurl = pro.productimageurl;
                _pro3.img180 = pro.img180;
                _pro3.classcode = pro.classcode;
                _pro3.productstatustype = pro.productstatustype;
                _pro3.quantity = pro.quantity;
                _pro3.xquantity = pro.xquantity;
                _pro3.producttag = pro.producttag;
                _pro3.formulationcode = pro.formulationcode;
                _pro3.categorytype = pro.categorytype;
                _resultTemp.productList3.add(_pro3);
            }
            _resultTemp.setRowCount(_uipTemp.getProductList().size());
            return _resultTemp;
        }
    }


    private static UIProduct FilterNormal(UIProduct _uiproduct, String[] MustKeys, String[] SynonArr) {
        UIProduct _uipTemp = _uiproduct;
        UIProduct _uipTemp2 = _uiproduct;
        UIProduct _uipTemp3 = _uiproduct;

        //没有同义词的词组,对搜索结果交集处理
        if (SynonArr.length == 0) {
            for (int i = 0; i < MustKeys.length; i++) {
                _uipTemp = FilterProduct(_uipTemp, MustKeys[i], true);
            }
        } else {
            //对MustKeys交集处理,对同义词并集处理
            for (int i = 0; i < MustKeys.length; i++) {
                _uipTemp = FilterProduct(_uipTemp, MustKeys[i], true);
            }

            if (_uipTemp.productList.size() == 0) {
                for (int i = 0; i < MustKeys.length; i++) {
                    _uipTemp2 = FilterProduct(_uipTemp2, MustKeys[i], false);
                }
                _uipTemp = _uipTemp2.productList.size() == 0 ? _uiproduct : _uipTemp2;
                _uipTemp.setRowCount(_uipTemp.getRowCount() + _uipTemp2.productList.size());
            }

            //将同义词的搜索结果加上
            _uipTemp3 = FilterProduct2(_uiproduct, SynonArr);
            if (_uipTemp3.getProductList().size() > 0) {
                _uipTemp.getProductList().addAll(_uipTemp3.getProductList());
                _uipTemp.setRowCount(_uipTemp.getRowCount() + _uipTemp3.getRowCount());
            }

        }

        //关键词没有搜索到,对数据进行并集处理处理
        if (_uipTemp.productList.size() == 0) {
            for (int i = 0; i < MustKeys.length; i++) {
                _uipTemp2 = FilterProduct(_uipTemp2, MustKeys[i], false);
            }

            //_uipTemp = _uipTemp2.productList.size() == 0 ? _uiproduct : _uipTemp2;
            if(_uipTemp2.productList.size()==0)
            {
                //可以认为是提问式
                if(MustKeys.length>=15){
                    _uipTemp=_uiproduct;
                }else{
                    _uipTemp=_uipTemp2;
                }

            }else {
                _uipTemp = _uipTemp2;
            }
        }

        return _uipTemp;

    }


    private static UIProduct FilterProduct(UIProduct _uiproduct, String[] tonyipy,String [] mustkeys) {
        UIProduct _uip = new UIProduct();
        List<String> nonProducts = DB.GetNONDisplay();
        for (int i = 0; i < _uiproduct.getProductList().size(); i++) {
            Product _pro = _uiproduct.productList.get(i);
            String productname_pyall = ChineseToPinyin.getPingYin(_pro.getProductname()).toLowerCase();
            String manufacturer_pyall = ChineseToPinyin.getPingYin(_pro.getManufacturer()).toLowerCase();
            String commontitle_pyall = ChineseToPinyin.getPingYin(_pro.getCommontitle()).toLowerCase();
            String introduction_pyall = ChineseToPinyin.getPingYin(_pro.getIntroduction()).toLowerCase();
            String producttag_pyall = ChineseToPinyin.getPingYin(_pro.getProducttag()).toLowerCase();
            if ((hascontact(productname_pyall, tonyipy)
                    || hascontact(manufacturer_pyall, tonyipy)
                    || hascontact(commontitle_pyall, tonyipy)
                    || hascontact(introduction_pyall, tonyipy)
                    || hascontact(producttag_pyall, tonyipy))
                    && contactCode(_pro.getProductcode(), nonProducts) == false) {
                _uip.getProductList().add(_pro);
            }
        }

        UIProduct _uip2 = new UIProduct();

        if(mustkeys!=null) {
            if (mustkeys.length > 0) {
                for (int i = 0; i < _uip.getProductList().size(); i++) {
                    Product _pro = _uip.productList.get(i);
                    if (_pro.getProductname().indexOf(mustkeys[0]) > -1
                            || _pro.getManufacturer().indexOf(mustkeys[0]) > -1) {
                        _uip2.getProductList().add(_pro);
                    }
                }
            }
        }

        if (_uip2.getProductList().size() > 0) {
            _uip2.setRowCount(_uip2.getProductList().size());
            return _uip2;
        }

        _uip.setRowCount(_uip.getProductList().size());
        return _uip;
    }

    private static UIProduct FilterProduct(UIProduct _uiproduct, String _input, boolean is) {
        UIProduct _uip = new UIProduct();
        Boolean brance = false;
        List<String> nonProducts = DB.GetNONDisplay();
        _input = _input.toUpperCase().trim();
        for (int i = 0; i < _uiproduct.productList.size(); i++) {
            Product _pro = _uiproduct.productList.get(i);
            if (is) {
                if (i == 0) {
                    if (_pro.productname.toUpperCase().trim().contains(_input.trim())
                            || _pro.manufacturer.toUpperCase().trim().contains(_input.trim())) {
                        brance = true;
                    }
                }
            }
            if (brance) {
                if (
                        (_pro.productname.toUpperCase().trim().contains(_input) || _pro.manufacturer.toUpperCase().trim().contains(_input)) &&
                        (_pro.productcode.toUpperCase().trim().contains(_input)
                                || _pro.productname.toUpperCase().trim().contains(_input)
                                || _pro.commontitle.toUpperCase().trim().contains(_input)
                                || _pro.introduction.toUpperCase().trim().contains(_input)
                                || _pro.manufacturer.toUpperCase().trim().contains(_input)
                                || _pro.producttag.toUpperCase().trim().contains(_input)
                                || _pro.pyall.toUpperCase().contains(_input)
                                || _pro.pyhc.toUpperCase().contains(_input))
                        && contactCode(_pro.getProductcode(), nonProducts) == false)
                {
                    _uip.productList.add(_pro);

                }
            } else {
                if (
                        (_pro.productcode.toUpperCase().trim().contains(_input) ||
                        _pro.productname.toUpperCase().trim().contains(_input) ||
                        _pro.commontitle.toUpperCase().trim().contains(_input) ||
                        _pro.introduction.toUpperCase().trim().contains(_input) ||
                        _pro.manufacturer.toUpperCase().trim().contains(_input) ||
                        _pro.producttag.toUpperCase().contains(_input) ||
                        _pro.pyall.toUpperCase().contains(_input) ||
                        _pro.pyhc.toUpperCase().contains(_input)) && contactCode(_pro.getProductcode(), nonProducts) == false)
                {
                    _uip.productList.add(_pro);
                }
            }
        }
        return _uip;
    }


    private static UIProduct FilterProduct2(UIProduct _uiproduct, String[] keys) {
        UIProduct _uip = new UIProduct();
        List<String> nonProducts = DB.GetNONDisplay();
        for (int i = 0; i < _uiproduct.getProductList().size(); i++) {
            Product _pro = _uiproduct.productList.get(i);
            String productname = _pro.getProductname().toLowerCase().trim();
            String manufacturer = _pro.getManufacturer().toLowerCase().trim();
            String commontitle = _pro.getCommontitle().toLowerCase().trim();
            String introduction = _pro.getIntroduction().toLowerCase().trim();
            String producttag = _pro.getProducttag().toLowerCase().trim();
            if ((hascontact(productname, keys)
                    || hascontact(manufacturer, keys)
                    || hascontact(commontitle, keys)
                    || hascontact(introduction, keys)
                    || hascontact(producttag, keys)) && contactCode(_pro.getProductcode(), nonProducts) == false) {
                _uip.getProductList().add(_pro);
            }
        }

        _uip.setRowCount(_uip.getProductList().size());
        return _uip;
    }


    protected static boolean contactCode(String productcode, List<String> _list) {
        for (String _productcode : _list) {
            if (_productcode.trim().equals(productcode.trim())) {
                return true;
            }
        }
        return false;
    }


    protected static boolean hascontact(String content, String[] keys) {
        for (String key : keys) {
            String[] _keyArr = key.toLowerCase().trim().split(" ");

            boolean isAsc = true;
            List<String> bools = new ArrayList<String>();
            for (int i = 0; i < _keyArr.length; i++) {
                if (content.contains(_keyArr[i])) {
                    bools.add("true");
                } else {
                    bools.add("false");
                }

            }

            for (String bolstr : bools) {
                if ("false".equals(bolstr)) {
                    isAsc = false;
                    break;
                }
            }


            boolean isDesc = true;
            List<String> bools2 = new ArrayList<String>();
            for (int i = _keyArr.length - 1; i >= 0; i--) {
                if (content.contains(_keyArr[i])) {
                    bools2.add("true");
                } else {
                    bools2.add("false");
                }
            }

            for (String bolstr : bools2) {
                if ("false".equals(bolstr)) {
                    isDesc = false;
                    break;
                }
            }
            if (isAsc || isDesc) {
                return true;
            }
        }
        return false;

    }



}