package com.lj.others;

import com.lj.lucene.B2BUtil;
import com.lj.lucene.CMSUtil;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.ResultSet;

/**
 * Created by john on 2018/10/19.
 */
public class HTTPCreateAllB2BIndex {

    public B2BUtil b2bUtil = null;

    public HTTPCreateAllB2BIndex(B2BUtil _b2bUtil) {
        this.b2bUtil = _b2bUtil;
    }

    public void createallindex(HttpServletRequest req, HttpServletResponse response) {
        String _callback = req.getParameter("callback") == null ? "" : req.getParameter("callback");
        ResultSet rs = SQLHelper.executeQuery("USE B2BMall " +
                "SELECT \n" +
                "A.ProductCode,\n" +
                "A.ProductName,\n" +
                "A.BarCode,\n" +
                "A.ApprovalNumber,\n" +
                "A.PrescriptionType,\n" +
                "A.Packing,\n" +
                "A.CommonTitle,\n" +
                "A.Manufacturer,\n" +
                "A.Introduction,\n" +
                "ISNULL(A.[Manual],'') [Manual],\n" +
                "ISNULL(A.Standards,'') Standards,\n" +
                "ISNULL(A.Dosage,'') Dosage,\n" +
                "ISNULL(A.Characters,'') Characters,\n" +
                "ISNULL(A.Adverse,'') Adverse,\n" +
                "ISNULL(A.Taboo,'') Taboo,\n" +
                "ISNULL(A.Precautions,'') Precautions,\n" +
                "ISNULL(A.Child,'') Child,\n" +
                "ISNULL(A.OlderPatients,'') OlderPatients,\n" +
                "ISNULL(A.PregnantWoman,'') PregnantWoman,\n" +
                "ISNULL(A.DrugInteractions,'') DrugInteractions,\n" +
                "ISNULL(A.Overdose,'') Overdose,\n" +
                "ISNULL(A.Pharmaco,'') Pharmaco,\n" +
                "ISNULL(A.Pharmacokinetics,'') Pharmacokinetics ,\n" +
                "ISNULL(A.PackingProduct,'') PackingProduct,\n" +
                "ISNULL(A.MarketPrice,0) MarketPrice,\n" +
                "ISNULL(A.ClassCode,'') ClassCode,\n" +
                "ISNULL(A.CategoryCode,'') CategoryCode,\n" +
                "ISNULL(A.ProductImgUrl,'') ProductImgUrl,\n" +
                "ISNULL(A.AvgPrice,0) AvgPricem,\n" +
                "ISNULL(A.LastPrice,0) LastPrice,\n" +
                "ISNULL(A.PreviousPrice,0) PreviousPrice,\n" +
                "ISNULL(A.Price1,0) Price1,\n" +
                "ISNULL(A.Price2,0) Price2,\n" +
                "ISNULL(A.Price3,0) Price3,\n" +
                "ISNULL(A.Price4,0) Price4,\n" +
                "A.IsPiece,\n" +
                "ISNULL(A.WholeQuantity,0) WholeQuantity,\n" +
                "ISNULL(A.ERPID,'') ERPID,\n" +
                "ISNULL(A.BrandName,'') BrandName,\n" +
                "ISNULL(A.Unit,'') Unit,\n" +
                "ISNULL(A.PieceQuantity ,'') PieceQuantity,\n" +
                "ISNULL(A.ProductStatusType ,0) ProductStatusType,\n" +
                "C.Stock Stock, \n" +
                "ISNULL(C.BatchCode,'') BatchCode,\n" +
                "ISNULL(C.ValidityDate,'') ValidityDate " +
                "FROM Product A\n" +
                "OUTER APPLY\n" +
                "(\n" +
                " SELECT ISNULL(SUM(B.StockAmount),0) Stock,MAX(B.BatchCode) BatchCode,MAX(B.ValidityDate) ValidityDate  FROM dbo.ProductBatch B WHERE B.ProductCode=A.ProductCode and B.InvaildStatus=0\n" +
                ") C\n" +
                "  ");

        String[] not_analyzedColumns = {"BarCode", "PrescriptionType", "IsPiece", "WholeQuantity", "ERPID", "Stock", "ProductImgUrl", "ClassCode", "WholeQuantity", "ERPID","ProductStatusType","BatchCode","ValidityDate"};
        String[] numericColumns = {"AvgPricem", "LastPrice","PreviousPrice","Price1","Price2","Price3","Price4"};
        String[] pinyinColumns = {"BrandName", "ProductName","Manufacturer"};
        int rowCount = b2bUtil.CreateIndex(rs, not_analyzedColumns, numericColumns, pinyinColumns);
        Other.ResponseResult(response, _callback, String.valueOf(rowCount));
    }
}
