package com.lj.others;

import com.lj.lucene.CMSUtil;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;

import java.sql.ResultSet;
import java.util.List;

/**
 * Created by john on 2018/6/14.
 */
public class IndexThread extends Thread {

    private String type;
    private String daid;
    private CMSUtil cmsUtil;

    public IndexThread(String type, String daid, CMSUtil _cmsUtil) {
        this.type = type;
        this.daid = daid;
        this.cmsUtil = _cmsUtil;
    }

    @Override
    public void run() {
        switch (this.type) {
            case "update":
                updateIndex();
                break;
            case "insert":
                insertIndex();
                break;
            case "delete":
                deleteIndex();
                break;
            default:
                break;
        }

    }

    public void updateIndex() {
        ResultSet rs = SQLHelper.executeQuery("USE LJCMS  " +
                "SELECT  T.Id,T.Title,T.SubTitle,T.Paths,T.[Image],T.Summary,T.IsHomePageTop,T.IsCategoryTop,T.KeyWord,T.CreationDate,T.PV,T.ArticleContent " +
                "FROM dbo.DrugGuideArticles T where T.IsDelete=0 AND T.AuditStatus=1 AND T.id='" + daid + "'");
        String[] not_analyzedColumns = {"id", "paths", "image", "ishomepagetop", "iscategorytop", "pv"};
        String[] tonumColumns = {"creationdate"};
        String[] notStoreColumns = {};

        List<Document> docs = ResultSetToObject.CMSResultSetToDocuments(rs, not_analyzedColumns, tonumColumns, notStoreColumns);
        cmsUtil.DeleteSiginIndexByKey("id",daid);

        if (docs.size() > 0)
            cmsUtil.InsertSingleIndex(docs.get(0));
    }

    public void insertIndex() {
        ResultSet rs = SQLHelper.executeQuery("USE LJCMS  SELECT  T.Id,T.Title,T.SubTitle,T.Paths,T.[Image],T.Summary,T.IsHomePageTop,T.IsCategoryTop,T.KeyWord,T.CreationDate,T.PV,T.ArticleContent " +
                "FROM dbo.DrugGuideArticles T where T.IsDelete=0 AND T.AuditStatus=1 AND T.id='" + daid + "'");
        String[] not_analyzedColumns = {"id", "paths", "image", "ishomepagetop", "iscategorytop", "pv"};
        String[] tonumColumns = {"creationdate"};
        String[] notStoreColumns = {};
        List<Document> docs = ResultSetToObject.CMSResultSetToDocuments(rs, not_analyzedColumns, tonumColumns, notStoreColumns);
        if (docs.size() > 0)
            cmsUtil.InsertSingleIndex(docs.get(0));
    }

    public void deleteIndex() {
        cmsUtil.DeleteSiginIndexByKey("id", daid);
    }
}