package com.lj.others;

import com.lj.lucene.IndexUtil;
import com.lj.lucene.IndexUtil_R;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.IndexWriterConfig;
import org.apache.lucene.index.OrdTermState;
import org.apache.lucene.index.Term;
import org.apache.lucene.store.*;
import org.apache.lucene.util.AttributeSource;
import org.wltea.analyzer.lucene.IKAnalyzer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.Source;
import java.io.*;
import java.nio.file.Paths;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;
/**
 * Created by john on 2018/6/21.
 */
public class ProductHTTPMethod {

    static IndexUtil indexUtil = null;
    static IndexUtil_R indexUtil_r = null;
    static final int SOURFCE_WORDS_MAX = 5;
    static final int PINYIN_WORDS_MAX = 2;
    static final int SPLIT_WORDS_INDEX = 0;

    static final int PINYIN_INVALID_LENGTH = 3;
    static final int CHINESE_INVALID_LENGTH = 1;


    public ProductHTTPMethod(IndexUtil _indexUtil, IndexUtil_R _indexUtil_r) {
        this.indexUtil = _indexUtil;
        this.indexUtil_r = _indexUtil_r;
    }

    public void search(HttpServletRequest req, HttpServletResponse response) {
        String _callback = req.getParameter("callback") == null ? "" : req.getParameter("callback");
        String _input = req.getParameter("kw") == null ? "" : req.getParameter("kw");
        int _pageindex = req.getParameter("pageindex") == null ? 1 : Integer.parseInt(req.getParameter("pageindex"));
        int _pagesize = req.getParameter("pagesize") == null ? 6 : Integer.parseInt(req.getParameter("pagesize"));
        boolean _ishlight = req.getParameter("ishlight") == null ? false : true;
        boolean _boolSmart = req.getParameter("smart") == null ? false : true;
        if ("".equals(_input)) {
            String json = "{\"result\":{\"productList\":[],\"rowCount\":0}}";
            Other.ResponseJson(response, _callback, json);
            return;
        }
        String ip = req.getParameter("ip") == null ? "127.0.0.1" : req.getParameter("ip");
        //调用百度提问式词库
        _input = Other.GetBaidukw(_input);
        //使用百度纠错功能
        //_input = Other.GetBaiduJiuError(_input);

        // List<String> rejectcodes = Other.getrejectCodeByIp(ip);
        boolean isEnglish = Other.isEnglish(_input);
        List<String> rejectcodes = new ArrayList<String>();

        //获取前端传来的字段参数，多个字段用英文逗号分隔
        List<String> _fields = Config.getProductSearchFileds();
        String fields = req.getParameter("fields");
        if (fields != null) {
            String[] _fieldsTemp = fields.split(",");
            for (int i = 0; i < _fieldsTemp.length; i++) {
                if (!_fields.contains(_fieldsTemp[i])) {
                    _fields.add(_fieldsTemp[i]);
                }
            }
        }
        //获取前端传来的排序,支持多个字段排序，多个字段之间用英文分隔 sort=IsHomePageTop-DESC,PV-ASC
        String _sort = req.getParameter("sort");//== null ? "views-desc" : req.getParameter("sort");
        String _range = req.getParameter("range");
        //字段筛选
        String _isprescription = req.getParameter("isprescription");
        String _formulationcode = req.getParameter("formulationcode");
        String _hastockprice = req.getParameter("hastockprice");

        //记录没有分词时的关键词
        String _sinput = _input;
        String[] kwsTemp = Config.DealSynonym.Deal(_input, true).trim().split(" ");
        List<String> keysList = Arrays.asList(kwsTemp);
        if (isEnglish)
            keysList = keysList.stream().filter((String w) -> w.length() > PINYIN_INVALID_LENGTH).collect(Collectors.toList());
        else
            keysList = keysList.stream().filter((String w) -> w.length() > CHINESE_INVALID_LENGTH).collect(Collectors.toList());

        String[] keys = keysList.toArray(new String[keysList.size()]);
        _input = org.apache.commons.lang.StringUtils.join(keysList.toArray(), " ");
        String[] tongyipy = Other.GetPinYinListAttach(_input);
        //获取同义词
        List<String> synonyms = Other.findsynonyms(_sinput, keysList);
        String[] SynonArr = synonyms.toArray(new String[synonyms.size()]);
        boolean hassynonyms = synonyms.size() > 0 ? true : false;
        //去掉同义词,这个地方选交集
        String[] MustKeys = null;
        if (!isEnglish) {
            MustKeys = Other.removesynonyms(keys, synonyms);
        } else {
            MustKeys = new String[1];
            MustKeys[0] = _sinput;
        }

        boolean Ispinyincheck = false;
        //判断是否分词过
        //获取长度最大的元素的索引
        if (keys.length > 0) {
            //分词过后最大的元素
            String _maxword = Other.GetMaxItem(keys);
            //已经分过词了
            if (_sinput.toUpperCase().trim().indexOf(_maxword.toUpperCase().trim()) > SPLIT_WORDS_INDEX ||
                    (_sinput.toUpperCase().trim().length() <= SOURFCE_WORDS_MAX & _maxword.toUpperCase().length() == PINYIN_WORDS_MAX)) {
                Ispinyincheck = true;
            }
        }

        //输入关键词长度大于5需要分词,不开启拼音纠错
        if (_sinput.length() > SOURFCE_WORDS_MAX) {
            Ispinyincheck = false;
        }

        UIProduct uiProduct = null;
        if (Ispinyincheck == true || "".equals(_input.trim()) || isEnglish) {
            //拼音同义词的转换
            if (keys.length < PINYIN_WORDS_MAX) {
                tongyipy = Other.GetPinYinListAttach(_sinput);
            }
            String _pinyins = org.apache.commons.lang.StringUtils.join(tongyipy, " ");
            uiProduct = indexUtil_r.SearchProduct(_fields, _pinyins.trim(), _ishlight);
            Ispinyincheck = true;
        } else {

            uiProduct = indexUtil_r.SearchProduct(_fields, _input.trim(), _ishlight);
            Ispinyincheck = false;
        }


        Object FilteruiProduct = Filter.FilterProduct(uiProduct, MustKeys,
                _range, _sort,
                _isprescription, _formulationcode,
                _hastockprice, _pagesize,
                _pageindex, rejectcodes, Ispinyincheck, tongyipy, SynonArr);
        JSONObject json = JSONObject.fromObject(FilteruiProduct);//将java对象转换为json对象

        Other.ResponseResult(response, _callback, json.toString());
    }

    public void update(HttpServletRequest request, HttpServletResponse response) {
        String productcode = request.getParameter("productcode");
        ResultSet rs = SQLHelper.executeQuery(" USE MallPortal   " +
                "SELECT  a.ProductCode,\n" +
                "                ISNULL(a.ProductName,'') ProductName,\n" +
                "                ISNULL(CommonTitle,'') CommonTitle,\n" +
                "                ISNULL(ProfitLevel,'') ProfitLevel,\n" +
                "                ISNULL(Introduction,'')Introduction,\n" +
                "                ISNULL(Manufacturer,'')Manufacturer,\n" +
                "                CASE Grade \n" +
                "                        when 1 then DiscountPrice1\n" +
                "                        when 2 then DiscountPrice2\n" +
                "                        when 3 then DiscountPrice3\n" +
                "                        when 4 then DiscountPrice4\n" +
                "                        when 5 then DiscountPrice5\n" +
                "                        else ISNULL(a.OurPrice,0)\n" +
                "                        end  as OurPrice,\n" +
                "                ISNULL(MarketPrice,0) MarketPrice,\n" +
                "                ISNULL(Packing,'') Packing,\n" +
                "                ISNULL(ThumbnailUrl,'') ThumbnailUrl,\n" +
                "                ISNULL(PrescriptionType,'') PrescriptionType ,\n" +
                "                ISNULL(Img100,'') Img100,\n" +
                "                ISNULL(ProductImageUrl,'') ProductImageUrl,\n" +
                "                ISNULL(Img180,'') Img180,\n" +
                "                ISNULL(Views,0) Views ,\n" +
                "                ISNULL(ClassCode,'') ClassCode,\n" +
                "                ISNULL(ProductStatusType,0) ProductStatusType,\n" +
                "                ISNULL(Quantity,0) Quantity,\n" +
                "                ISNULL(XQuantity,0) XQuantity,\n" +
                "                ISNULL(ProductTag,'') ProductTag,\n" +
                "                ISNULL(FormulationCode,0) FormulationCode,\n" +
                "                ISNULL(c.BrandName,'') BrandName, \n" +
                "                ISNULL(a.PurchasePrice,'') PurchasePrice, \n" +
                "                case Grade \n" +
                "                when 1 then Amount1\n" +
                "                when 2 then Amount2\n" +
                "                when 3 then Amount3\n" +
                "                when 4 then Amount4\n" +
                "                when 5 then Amount5\n" +
                "                else 1\n" +
                "                end  as CategoryType\n" +
                "                from Product (nolock) as a left join ProductDiscount (nolock) as b on a.ProductCode=b.ProductCode and b.PlatformId=1 And GETDATE()<b.EndTime AND b.StartTime< GETDATE() \n" +
                "                LEFT JOIN dbo.ProductBrand c ON c.BrandCode=a.BrandCode \n" +
                "                where  a.IsGifts<>1 and a.ProductStatusType IN (2,4) and a.productcode=" + productcode);
        String[] not_analyzedColumns = {"productstatustype", "prescriptiontype", "formulationcode", "marketprice", "packing", "thumbnailurl", "img100", "productpmageurl", "img180", "classcode", "quantity", "xquantity", "categorytype"};
        String[] numericColumns = {"ourprice", "views", "purchaseprice"};
        String[] pinyinColumns = {"brandname", "commontitle","manufacturer"};
        List<Document> docs = ResultSetToObject.ProductResultSetToDocuments(rs, not_analyzedColumns, numericColumns, pinyinColumns);
        Other.ResponseResult(response, "更新条数：" + docs.size());
        indexUtil.DeleteSiginIndexByKey("productcode", productcode);
        Other.ResponseResult(response, "删除索引：" + docs.size());
        if (docs.size() > 0) {
            indexUtil.InsertSiginIndex(docs.get(0));
            Other.ResponseResult(response, "update");
            String logPath = properties.getvalueBykey("log");
            Date dt = new Date();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            String logFilePath = logPath + "/" + sdf.format(dt) + ".txt";
            CreateLogFile(logFilePath);
            String content = productcode + " 更新时间：" + dt.toString();
            appendlog(logFilePath,content);
        }
        Other.ResponseResult(response, "1");
    }

    public void think(HttpServletRequest request, HttpServletResponse response) {
        String _callback = request.getParameter("callback") == null ? "" : request.getParameter("callback");
        String _input = request.getParameter("kw") == null ? "" : request.getParameter("kw");
        String _showfield = request.getParameter("showfield") == null ? "commontitle" : request.getParameter("showfield");
        int _size = request.getParameter("size") == null ? 15 : Integer.parseInt(request.getParameter("size"));
        _input = Other.GetBaiduJiuError(_input);
        String[] kwsTemp = Config.DealSynonym.Deal(_input, true).trim().split(" ");
        List<String> keysList = Arrays.asList(kwsTemp);
        keysList = keysList.stream().filter((String w) -> w.length() > 1).collect(Collectors.toList());
        String _sinput = _input;
        String[] keys = keysList.toArray(new String[keysList.size()]);
        _input = org.apache.commons.lang.StringUtils.join(keys, " ");
        String _pinyins = org.apache.commons.lang.StringUtils.join(keysList.toArray(), " ");
        //获取同义词
        List<String> synonyms = Other.findsynonyms(_sinput, keysList);
        //去掉同义词
        String[] newkeys = Other.removesynonyms(keys, synonyms);
        //新词累加同义词
        List<String> ljkey = new ArrayList<String>();

        ljkey.addAll(Arrays.asList(newkeys));
        ljkey.addAll(synonyms);

        String[] _fields = Config.getlianxianSearchFileds();
        List<Lianxian> _list = indexUtil_r.ThinkSearch(_input, _fields, _showfield);
        List<Lianxian> _rsultList = new ArrayList<Lianxian>();
        for (int i = _list.size() - 1; i >= 0; i--) {
            if (hasConttent(_list.get(i).getKindname(), ljkey) == true
                    || hasConttent(_list.get(i).getPyall(), ljkey) == true
                    || hasConttent(_list.get(i).getPyhc(), ljkey) == true) {
                _rsultList.add(_list.get(i));
            }
        }
        if (_rsultList.size() > _size) {
            _rsultList = _rsultList.subList(0, _size);
        }
        JSONArray json = JSONArray.fromObject(_rsultList);//将java对象转换为json对象
        Other.ResponseJson(response, _callback, json.toString());
    }

    private boolean hasConttent(String key, List<String> keys) {
        for (String _key : keys) {
            if (key.toUpperCase().trim().contains(_key.toUpperCase().trim())) {
                return true;
            }
        }
        return false;
    }


    private void CreateLogFile(String logFilePath) {
        File filename = new File(logFilePath);
        if (!filename.exists()) {
            try {
                filename.createNewFile();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    private void appendlog(String filePath, String content) {
        FileWriter fw = null;
        try {
            //如果文件存在，则追加内容；如果文件不存在，则创建文件
            File f = new File(filePath);
            fw = new FileWriter(f, true);
        } catch (IOException e) {
            e.printStackTrace();
        }

        PrintWriter pw = new PrintWriter(fw);
        pw.println(content+"\\r\\n");
        pw.flush();
        try {
            fw.flush();
            pw.close();
            fw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
