package com.lj.others;

import com.lj.lucene.IndexUtil;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.sql.ResultSet;
import java.util.List;

/**
 * Created by john on 2018/6/15.
 */
public class ProductThread extends Thread {
    private String type;
    private String ProductCode;
    private IndexUtil indexUtil;

    public ProductThread(String type, String ProductCode, IndexUtil _indexUtil) {
        this.type = type;
        this.ProductCode = ProductCode;
        this.indexUtil = _indexUtil;
    }

    @Override
    public void run() {
        switch (this.type) {
            case "update":
                updateIndex();
                break;
            case "insert":
                insertIndex();
                break;
            default:
                break;
        }

    }

    public void updateIndex() {
        ResultSet rs = SQLHelper.executeQuery(" USE MallPortal   " +
                "SELECT  a.ProductCode,\n" +
                "                ISNULL(a.ProductName,'') ProductName,\n" +
                "                ISNULL(CommonTitle,'') CommonTitle,\n" +
                "                ISNULL(ProfitLevel,'') ProfitLevel,\n" +
                "                ISNULL(Introduction,'')Introduction,\n" +
                "                ISNULL(Manufacturer,'')Manufacturer,\n" +
                "                CASE Grade \n" +
                "                        when 1 then DiscountPrice1\n" +
                "                        when 2 then DiscountPrice2\n" +
                "                        when 3 then DiscountPrice3\n" +
                "                        when 4 then DiscountPrice4\n" +
                "                        when 5 then DiscountPrice5\n" +
                "                        else ISNULL(a.OurPrice,0)\n" +
                "                        end  as OurPrice,\n" +
                "                ISNULL(MarketPrice,0) MarketPrice,\n" +
                "                ISNULL(Packing,'') Packing,\n" +
                "                ISNULL(ThumbnailUrl,'') ThumbnailUrl,\n" +
                "                ISNULL(PrescriptionType,'') PrescriptionType ,\n" +
                "                ISNULL(Img100,'') Img100,\n" +
                "                ISNULL(ProductImageUrl,'') ProductImageUrl,\n" +
                "                ISNULL(Img180,'') Img180,\n" +
                "                ISNULL(Views,0) Views ,\n" +
                "                ISNULL(ClassCode,'') ClassCode,\n" +
                "                ISNULL(ProductStatusType,0) ProductStatusType,\n" +
                "                ISNULL(Quantity,0) Quantity,\n" +
                "                ISNULL(XQuantity,0) XQuantity,\n" +
                "                ISNULL(ProductTag,'') ProductTag,\n" +
                "                ISNULL(FormulationCode,0) FormulationCode,\n" +
                "                ISNULL(c.BrandName,'') BrandName, \n" +
                "                ISNULL(a.PurchasePrice,'') PurchasePrice, \n" +
                "                case Grade \n" +
                "                when 1 then Amount1\n" +
                "                when 2 then Amount2\n" +
                "                when 3 then Amount3\n" +
                "                when 4 then Amount4\n" +
                "                when 5 then Amount5\n" +
                "                else 1\n" +
                "                end  as CategoryType\n" +
                "                from Product (nolock) as a left join ProductDiscount (nolock) as b on a.ProductCode=b.ProductCode and b.PlatformId=1 And GETDATE()<b.EndTime AND b.StartTime< GETDATE() \n" +
                "                LEFT JOIN dbo.ProductBrand c ON c.BrandCode=a.BrandCode \n" +
                "                where  a.IsGifts<>1 and a.ProductStatusType IN (2,4) and a.productcode=" + ProductCode);
        String[] not_analyzedColumns = {"productstatustype", "prescriptiontype", "formulationcode", "marketprice", "packing", "thumbnailurl", "img100", "productpmageurl", "img180", "classcode", "quantity", "xquantity", "categorytype"};
        String[] numericColumns = {"ourprice", "views", "purchaseprice"};
        String[] pinyinColumns = {"brandname", "commontitle"};
        List<Document> docs = ResultSetToObject.ProductResultSetToDocuments(rs, not_analyzedColumns, numericColumns, pinyinColumns);
        System.out.println(docs.size());
        indexUtil.DeleteSiginIndexByKey("productcode",ProductCode);
        if (docs.size() > 0) {
            indexUtil.InsertSiginIndex(docs.get(0));
        }
    }

    public void insertIndex() {

        ResultSet rs = SQLHelper.executeQuery(" USE MallPortal   " +
                "SELECT  a.ProductCode,\n" +
                "                ISNULL(a.ProductName,'') ProductName,\n" +
                "                ISNULL(CommonTitle,'') CommonTitle,\n" +
                "                ISNULL(ProfitLevel,'') ProfitLevel,\n" +
                "                ISNULL(Introduction,'')Introduction,\n" +
                "                ISNULL(Manufacturer,'')Manufacturer,\n" +
                "                CASE Grade \n" +
                "                        when 1 then DiscountPrice1\n" +
                "                        when 2 then DiscountPrice2\n" +
                "                        when 3 then DiscountPrice3\n" +
                "                        when 4 then DiscountPrice4\n" +
                "                        when 5 then DiscountPrice5\n" +
                "                        else ISNULL(a.OurPrice,0)\n" +
                "                        end  as OurPrice,\n" +
                "                ISNULL(MarketPrice,0) MarketPrice,\n" +
                "                ISNULL(Packing,'') Packing,\n" +
                "                ISNULL(ThumbnailUrl,'') ThumbnailUrl,\n" +
                "                ISNULL(PrescriptionType,'') PrescriptionType ,\n" +
                "                ISNULL(Img100,'') Img100,\n" +
                "                ISNULL(ProductImageUrl,'') ProductImageUrl,\n" +
                "                ISNULL(Img180,'') Img180,\n" +
                "                ISNULL(Views,0) Views ,\n" +
                "                ISNULL(ClassCode,'') ClassCode,\n" +
                "                ISNULL(ProductStatusType,0) ProductStatusType,\n" +
                "                ISNULL(Quantity,0) Quantity,\n" +
                "                ISNULL(XQuantity,0) XQuantity,\n" +
                "                ISNULL(ProductTag,'') ProductTag,\n" +
                "                ISNULL(FormulationCode,0) FormulationCode,\n" +
                "                ISNULL(c.BrandName,'') BrandName, \n" +
                "                ISNULL(a.PurchasePrice,'') PurchasePrice, \n" +
                "                case Grade \n" +
                "                when 1 then Amount1\n" +
                "                when 2 then Amount2\n" +
                "                when 3 then Amount3\n" +
                "                when 4 then Amount4\n" +
                "                when 5 then Amount5\n" +
                "                else 1\n" +
                "                end  as CategoryType\n" +
                "                from Product (nolock) as a left join ProductDiscount (nolock) as b on a.ProductCode=b.ProductCode and b.PlatformId=1 And GETDATE()<b.EndTime AND b.StartTime< GETDATE() \n" +
                "                LEFT JOIN dbo.ProductBrand c ON c.BrandCode=a.BrandCode \n" +
                "                 where a.productcode=" + ProductCode);
        String[] not_analyzedColumns = {"productstatustype", "prescriptiontype", "formulationcode", "marketprice", "packing", "thumbnailurl", "img100", "productpmageurl", "img180", "classcode", "quantity", "xquantity", "categorytype"};
        String[] numericColumns = {"ourprice", "views", "purchaseprice"};
        String[] pinyinColumns = {"brandname", "commontitle"};

        List<Document> docs = ResultSetToObject.ProductResultSetToDocuments(rs, not_analyzedColumns, numericColumns, pinyinColumns);
        if (docs.size() > 0) {
            indexUtil.InsertSiginIndex(docs.get(0));
        }
    }

}
