package com.lj.others;

import com.lj.lucene.AnalyzerUtil;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
import org.apache.lucene.document.NumericDocValuesField;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created by john on 2018/6/20.
 */
public class ResultSetToObject {
    public static List<Document> CMSResultSetToDocuments(ResultSet rs, String[] not_analyzedColumns, String[] toMumColumns, String[] not_StoreColumns) {
        List<Document> _list = new ArrayList<Document>();
        ResultSetMetaData rsmd = null;
        int count = 0;
        try {
            rsmd = rs.getMetaData();
            count = rsmd.getColumnCount();
        } catch (SQLException e) {
            e.printStackTrace();
        }

        try {
            while (rs.next()) {
                Document document = new Document();
                for (int i = 0; i < count; i++) {
                    String columnName = rsmd.getColumnName(i + 1);
                    String columnContent = rs.getString(columnName.toLowerCase());
                    boolean _noanalyzedbool = Arrays.asList(not_analyzedColumns).contains(columnName.toLowerCase());
                    boolean _numberbool = Arrays.asList(toMumColumns).contains(columnName.toLowerCase());
                    boolean _notstorebool = Arrays.asList(not_StoreColumns).contains(columnName.toLowerCase());
                    if (_noanalyzedbool) {
                        document.add(new Field(columnName.toLowerCase(), columnContent, Field.Store.YES, Field.Index.NOT_ANALYZED));
                    } else if (_numberbool) {
                        String _date = TimeUtils.formatDate(TimeUtils.parse(columnContent));
                        document.add(new Field(columnName.toLowerCase(), columnContent, Field.Store.YES, Field.Index.NOT_ANALYZED));
                        document.add(new Field(columnName.toLowerCase() + "_2", _date, Field.Store.YES, Field.Index.NOT_ANALYZED));
                        document.add(new NumericDocValuesField(columnName.toLowerCase() + "_2", Long.valueOf(_date)));
                    } else if (_notstorebool) {
                        document.add(new Field(columnName.toLowerCase(), columnContent, Field.Store.NO, Field.Index.ANALYZED));
                    } else {
                        document.add(new Field(columnName.toLowerCase(), columnContent, Field.Store.YES, Field.Index.ANALYZED));
                    }
                }

                _list.add(document);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return _list;
    }

    public static List<Document> ProductResultSetToDocuments(ResultSet rs, String[] not_analyzedColumns, String[] numericColumns, String[] pinyinColumns) {

        List<Document> _list = new ArrayList<Document>();
        ResultSetMetaData rsmd = null;
        int count = 0;
        try {
            rsmd = rs.getMetaData();
            count = rsmd.getColumnCount();
        } catch (SQLException e) {
            e.printStackTrace();
        }

        try {
            while (rs.next()) {
                Document document = new Document();
                for (int i = 0; i < count; i++) {
                    String columnName = rsmd.getColumnName(i + 1);
                    String columnContent = rs.getString(columnName);
                    boolean _noanalyzedbool = Arrays.asList(not_analyzedColumns).contains(columnName.toLowerCase());
                    boolean _numericbool = Arrays.asList(numericColumns).contains(columnName.toLowerCase());
                    if (_numericbool) {
                        String _out = Other.getSequence(Long.parseLong(columnContent));
                        document.add(new Field(columnName.toLowerCase(), _out, Field.Store.YES, Field.Index.NOT_ANALYZED));
                        document.add(new NumericDocValuesField(columnName.toLowerCase(), Long.parseLong(_out)));
                    } else if (_noanalyzedbool) {
                        document.add(new Field(columnName.toLowerCase(), columnContent, Field.Store.YES, Field.Index.NOT_ANALYZED));
                    } else {
                        document.add(new Field(columnName.toLowerCase(), columnContent, Field.Store.YES, Field.Index.ANALYZED));
                    }
                }
                String _pinyinInput = "";
                for (int i = 0; i < pinyinColumns.length; i++) {
                    String columnsName = pinyinColumns[i];
                    String columnsContent = rs.getString(columnsName);
                    _pinyinInput = _pinyinInput + columnsContent;
                }
                try {

                    String pinyinString = AnalyzerUtil.displayTokens(AnalyzerUtil.convertSynonym(AnalyzerUtil.analyzeChinese(_pinyinInput, true)));

                    if (pinyinString == null)
                        pinyinString = "";
                    document.add(new Field("pyhc", ChineseToPinyin.getPinYinHeadChar(pinyinString), Field.Store.YES, Field.Index.ANALYZED));
                    document.add(new Field("pyall", ChineseToPinyin.getPingYin(pinyinString), Field.Store.YES, Field.Index.ANALYZED));
                    _list.add(document);


                } catch (Exception e) {
                    e.printStackTrace();

                }
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return _list;

    }

    public static List<Document> B2BProductResultSetToDocuments(ResultSet rs, String[] not_analyzedColumns, String[] numericColumns, String[] pinyinColumns) {

        List<Document> _list = new ArrayList<Document>();
        ResultSetMetaData rsmd = null;
        int count = 0;
        try {
            rsmd = rs.getMetaData();
            count = rsmd.getColumnCount();
        } catch (SQLException e) {
            e.printStackTrace();
        }

        try {
            while (rs.next()) {
                Document document = new Document();
                for (int i = 0; i < count; i++) {
                    String columnName = rsmd.getColumnName(i + 1);
                    String columnContent = rs.getString(columnName);
                    boolean _noanalyzedbool = Arrays.asList(not_analyzedColumns).contains(columnName.toLowerCase());
                    boolean _numericbool = Arrays.asList(numericColumns).contains(columnName.toLowerCase());
                    if (_numericbool) {
                        String _out = Other.getSequence(Long.parseLong(columnContent));
                        document.add(new Field(columnName.toLowerCase(), _out, Field.Store.YES, Field.Index.NOT_ANALYZED));
                        document.add(new NumericDocValuesField(columnName.toLowerCase(), Long.parseLong(_out)));
                    } else if (_noanalyzedbool) {
                        document.add(new Field(columnName.toLowerCase(), columnContent, Field.Store.YES, Field.Index.NOT_ANALYZED));
                    } else {
                        document.add(new Field(columnName.toLowerCase(), columnContent, Field.Store.YES, Field.Index.ANALYZED));
                    }
                }
                String _pinyinInput = "";
                for (int i = 0; i < pinyinColumns.length; i++) {
                    String columnsName = pinyinColumns[i];
                    String columnsContent = rs.getString(columnsName);
                    _pinyinInput = _pinyinInput + columnsContent;
                }
                try {

                    String pinyinString = AnalyzerUtil.displayTokens(AnalyzerUtil.convertSynonym(AnalyzerUtil.analyzeChinese(_pinyinInput, true)));

                    if (pinyinString == null)
                        pinyinString = "";
                    document.add(new Field("pyhc", ChineseToPinyin.getPinYinHeadChar(pinyinString), Field.Store.YES, Field.Index.ANALYZED));
                    document.add(new Field("pyall", ChineseToPinyin.getPingYin(pinyinString), Field.Store.YES, Field.Index.ANALYZED));
                    _list.add(document);


                } catch (Exception e) {
                    e.printStackTrace();

                }
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return _list;

    }

    public static List<ext_dict> GetExtDictList(ResultSet rs){
        List<ext_dict> _list = new ArrayList<ext_dict>();
        try {
            while (rs.next()) {
                if(rs.getString("words")!=null&!"".equals(rs.getString("words"))) {
                    ext_dict _ext_dict = new ext_dict();
                    _ext_dict.setId(Integer.parseInt(rs.getString("id")));
                    _ext_dict.setName(rs.getString("words"));
                    _list.add(_ext_dict);
                }
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return _list;

    }

    public static int getCount(ResultSet rs,String name){
        int result=0;
        try {
            while (rs.next()) {
                result=Integer.parseInt(rs.getString(name));
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return result;
    }

    public static String  getValue(ResultSet rs,String name){
        String result="";
        try {
            while (rs.next()) {
                result=rs.getString(name);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return result;
    }

}
