package com.lj.servlet;
import com.lj.lucene.B2BUtil;
import com.lj.lucene.CMSUtil;
import com.lj.lucene.IndexUtil;
import com.lj.others.Config;
import com.lj.others.HTTPCreateAllB2BIndex;
import com.lj.others.HTTPCreateAllCMSIndex;
import com.lj.others.HttpCreateAllProductIndex;
import org.wltea.analyzer.lucene.IKAnalyzer;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
/**
 * Created by john on 2018/6/27.
 */
public class CreateIndexServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String action = req.getParameter("action");
        switch (action) {
            case "product":
                createproductallindex(req, resp);
                break;
            case "cms":
                createcmsallindex(req, resp);
                break;
            case "b2b":
                createb2ballindex(req, resp);
                break;
            default:
                break;
        }
    }

    protected void createproductallindex(HttpServletRequest req, HttpServletResponse resp) {
        String IndexPath = com.lj.others.properties.getvalueBykey("product");
        IndexUtil indexUtil = new IndexUtil(IndexPath, new IKAnalyzer(true));
        HttpCreateAllProductIndex _p = new HttpCreateAllProductIndex(indexUtil);
        _p.createallindex(req, resp);
    }

    protected void createcmsallindex(HttpServletRequest req, HttpServletResponse resp) {
        String IndexPath = com.lj.others.properties.getvalueBykey("cms");
        CMSUtil cmsUtil = new CMSUtil(IndexPath, new IKAnalyzer(true));
        HTTPCreateAllCMSIndex _c = new HTTPCreateAllCMSIndex(cmsUtil);
        _c.createallindex(req, resp);
    }

    protected void createb2ballindex(HttpServletRequest req, HttpServletResponse resp) {
        String IndexPath = com.lj.others.properties.getvalueBykey("b2b");
        B2BUtil b2BUtil = new B2BUtil(IndexPath, new IKAnalyzer(true));
        HTTPCreateAllB2BIndex _b = new HTTPCreateAllB2BIndex(b2BUtil);
        _b.createallindex(req, resp);
    }
}
