package com.lj.servlet;

import com.lj.others.DayComplateRateSort;
import com.lj.others.OperatorMonthReport;
import com.lj.others.Other;
import com.lj.others.SQLHelper;
import net.sf.json.JSONArray;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;

/**
 * Created by john on 2019/2/25.
 */
public class KFReportServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        GetOperators(req,resp);
    }
    public void GetOperators(HttpServletRequest req,HttpServletResponse response) {
        Date nowDate = new Date();
        int year = nowDate.getYear() + 1900;
        int month = nowDate.getMonth() + 1;

        long startTime = System.currentTimeMillis();    //获取开始时间
        ResultSet rs = SQLHelper.executeQuery("" +
                "USE Mall\n" +
                "SELECT Operator,SalesAmount,GrossProfit,Type FROM Mall..OperatorMonthReport WHERE [Type]=3 AND DateMonth='" + year + "-" + month + "'");


        List<OperatorMonthReport> arr = new ArrayList<OperatorMonthReport>();
        try {
            while (rs.next()) {
                OperatorMonthReport omp = new OperatorMonthReport();
                omp.setOperator(rs.getString("Operator").toString());
                omp.setTargetSalesAmount(rs.getDouble("SalesAmount"));
                omp.setTargetGrossProfit(rs.getDouble("GrossProfit"));
                double[] result = GetSalesAmountMonthByOperators(omp.getOperator());

                omp.setMonthSalesAmount(result[0]);
                omp.setMonthPurchaseAmount(result[1]);

                double monthGrossProfitRate = (double) ((omp.getMonthSalesAmount() - omp.getMonthPurchaseAmount()) / (double) omp.getMonthSalesAmount());
                if (omp.getMonthSalesAmount() == 0) {
                    omp.setMonthGrossProfitRate(0);
                } else {
                    omp.setMonthGrossProfitRate(monthGrossProfitRate * 100);
                }

                int day = nowDate.getDate();
                int surplusDays = getSurplusDays(year, month);
                double targetDaySaleAmount = (double) (omp.getTargetSalesAmount() - omp.getMonthSalesAmount()) / (double) (surplusDays - day + 1);

                omp.setDaySalesAmount(GetSalesAmountDayByOperators(omp.getOperator()));

                if (omp.getTargetSalesAmount() < omp.getMonthSalesAmount()) {
                    targetDaySaleAmount = -omp.getDaySalesAmount();
                }
                omp.setTargetDaySalesAmount(targetDaySaleAmount);
                if (omp.getTargetDaySalesAmount() <= 0) {
                    omp.setDayComplateSalesAmountRate(100);
                } else {
                    double dayComplateSalesAmountRate = (double) omp.getDaySalesAmount() / (double) omp.getTargetDaySalesAmount();
                    omp.setDayComplateSalesAmountRate(dayComplateSalesAmountRate * 100);
                }
                arr.add(omp);
            }

            Collections.sort(arr, new DayComplateRateSort());
            JSONArray jsonarr = JSONArray.fromObject(arr);//将java对象转换为json对象

            String _callback = req.getParameter("callback") == null ? "" : req.getParameter("callback");
            Other.ResponseResult(response, _callback, jsonarr.toString());

        } catch (SQLException e) {
            e.printStackTrace();
        }
        long endTime = System.currentTimeMillis();    //获取结束时间
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//设置日期格式
        System.out.println("程序运行时间：" + (endTime - startTime) + "ms " + df.format(new Date()));    //输出程序运行时间
    }


    public double [] GetSalesAmountMonthByOperators(String Operator) {
        Date nowDate = new Date();
        int year = nowDate.getYear() + 1900;
        int month = nowDate.getMonth() + 1;
        String operatorId = "";
        ResultSet rs0 = SQLHelper.executeQuery("Use Expo10_Passport " +
                "SELECT Id FROM Expo10_Passport..Account WHERE NickName='" + Operator + "'\n");
        try {
            while (rs0.next()) {
                operatorId= rs0.getString("Id");
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }





       String sql="Use Mall" +
                "\n" +
                "SELECT SUM(Sum/100.0) SaleAmount,ISNULL(SUM(T2.ActualPrice*T2.Amount),0)/100.0 PurchaseAmount \n" +
        "FROM [Mall].[dbo].[Orders] T \n" +
                "LEFT JOIN [Mall].[dbo].[OrderProducts] T2 ON T2.OrdersCode=T.OrdersCode \n" +
                "WHERE T.OperateID='"+operatorId+"'\n" +
                "AND T.OrderStatus NOT IN (0,100,200) AND T.OrderTime>='"+year+"-"+month+"-1'";
        ResultSet rs = SQLHelper.executeQuery(sql);
        double[] arr = new double [2];
        try {

            while (rs.next()) {
                arr[0] = rs.getDouble("SaleAmount");
                arr[1] = rs.getDouble("PurchaseAmount");
            }
            return arr;
        } catch (SQLException e) {
            e.printStackTrace();
            arr[0] = 0;
            arr[1] = 0;
            return arr;
        }
    }


    public double GetSalesAmountDayByOperators(String Operator) {
        Date nowDate = new Date();
        int year = nowDate.getYear() + 1900;
        int month = nowDate.getMonth() + 1;
        int day = nowDate.getDate();

        String operatorId = "";
        ResultSet rs0 = SQLHelper.executeQuery("Use Expo10_Passport " +
                "SELECT Id FROM Expo10_Passport..Account WHERE NickName='" + Operator + "'\n");
        try {
            while (rs0.next()) {
                operatorId = rs0.getString("Id");
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }

        ResultSet rs = SQLHelper.executeQuery("Use Mall " +
                "SELECT SUM(Sum/100.0) SaleAmount\n" +
                "FROM [Mall].[dbo].[Orders] T \n" +
                "WHERE T.OperateID='"+operatorId+"'\n" +
                "AND T.OrderStatus NOT IN (0,100,200) AND T.OrderTime>='" + year + "-" + month + "-" + day + "'");
        try {
            double result = 0;
            while (rs.next()) {
                result = rs.getDouble("SaleAmount");
            }
            return result;
        } catch (SQLException e) {
            e.printStackTrace();
            return 0;
        }
    }


    public int getSurplusDays(int year, int month) {
        int days = 0;
        if (month != 2) {
            switch (month) {
                case 1:
                case 3:
                case 5:
                case 7:
                case 8:
                case 10:
                case 12:
                    days = 31;
                    break;
                case 4:
                case 6:
                case 9:
                case 11:
                    days = 30;

            }
        } else {
            // 闰年
            if (year % 4 == 0 && year % 100 != 0 || year % 400 == 0)
                days = 29;
            else
                days = 28;
        }
        return days;
    }


}
