package com.lj.servlet;



import com.lj.Sirui.HttpClientUtils;
import com.lj.Sirui.RSAUtils;
import net.sf.json.JSONObject;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by john on 2018/11/8.
 */
public class SiruiServlet extends HttpServlet {

    public String publicKey = "";//公钥
    public String entpId = "";//连锁ID，思瑞提供
    public String storeId = "";//门店ID，思瑞提供
    public String appId = "";//思瑞入口APPId
    public String appSecret = "";//思瑞APPSecret


    public String srAppid = "";


    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        super.doGet(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {



        String timeStamp = String.valueOf(new Date().getTime() / 1000);
        String nonce = "";

        Map<String, Object> dataMap = new HashMap<String, Object>();

        dataMap.put("entpId", entpId);//连锁ID，思瑞提供
        dataMap.put("storeId", storeId);//门店ID，思瑞提供
        dataMap.put("patientMobileNo", "");//用户手机号
        dataMap.put("age", "30");//用户年龄
        dataMap.put("sex", "男");//用户性别
        dataMap.put("patientName", "彭校园");//用户姓名
        dataMap.put("pharmacistMobileNo", "");//药师手机号
        dataMap.put("pharmacistName", "");//药师姓名
        dataMap.put("returnURL", "http://www.360lj.com");//第三方返回链接
        dataMap.put("deptName", "内科");//科室
        dataMap.put("chiefComplaint", "");//患者病情描述
        dataMap.put("thirdOrderNo", "");//第三方订单号，非必须
        dataMap.put("drugArrayInfo", "");//药品信息
        dataMap.put("imageInfo", "");//患者检验报告图片，非必须
        dataMap.put("appId", appId);//思瑞入口APPId


        JSONObject json = JSONObject.fromObject(dataMap);//将java对象转换为json对象
        String paramsString = json.toString();
        String encodeData = "";
        try {
            encodeData = RSAUtils.encryptByPublicKeyEx(paramsString, publicKey);
        } catch (Exception e) {
            e.printStackTrace();
        }

        String signature = RSAUtils.generateSignWithParamsString(appSecret, timeStamp, nonce, paramsString);
        Map<String, String> paraMap = new HashMap<String, String>();
        paraMap.put("srAppid", srAppid);
        paraMap.put("timestamp", timeStamp);
        paraMap.put("nonce", nonce);
        paraMap.put("encodeData", encodeData);
        paraMap.put("signature", signature);


        String resultData = HttpClientUtils.httpPost("http://baidu.com", paraMap);

    }

    private  Map<String,Object> getUserBaseInfo(String OrdersCode){
        Map<String, Object> dataMap = new HashMap<String, Object>();

        String sql="" +
                "USE Mall\n" +
                "SELECT TOP 1 * FROM Mall..PrescriptionRecord T WHERE  T.OrdersCode='TM258473155841785837'";

        ResultSet rs = com.lj.others.SQLHelper.executeQuery(sql);
        try {
            while(rs.next()){
                dataMap.put("OrdersCode",rs.getString("OrdersCode"));
                dataMap.put("UserName",rs.getString("UserName"));
                dataMap.put("Gender",rs.getString("Gender"));
                dataMap.put("Age",rs.getString("Age"));
                dataMap.put("DiseaseDiagnose",rs.getString("DiseaseDiagnose"));
                dataMap.put("AddUserName",rs.getString("AddUserName"));

                return dataMap;

            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return dataMap;
    }

}
